import java.awt.*;
import Dataset;

class DBSheetSC extends Canvas {

    Dataset data;
	Dimension preferredSize;
	DBSheet sheet;

	int transx =0;
	int transy =0;

	int c;
	int r;
	int xi = 4;
	int yi = 4;
	int colw = 50;
	int rowh = 16;
	int fonth = 13;

	boolean     showHead;
	String[]    displayName;
	int[]       displayWidth;
	Font        font;
	FontMetrics fontMetric;

	Dimension bfDim = new Dimension(10,10);
	Image bfImg;
	Graphics bfGr;

	DBSheetSC(DBSheet dbsheet, Dataset ds, Dimension prefSize, boolean head) {

//	    createBuffer();

        sheet = dbsheet;
	    data = ds;
        preferredSize = prefSize;
		showHead = head;


		displayName = new String[data.colCount];
		displayWidth = new int[data.colCount];
        for (c=0; c < data.colCount; c++) {
		    displayName[c] = new String(data.colName[c]);
		}
	}

	public Dimension minimumSize() {
        return preferredSize;
    }

	public Dimension preferredSize() {
        return preferredSize;
    }

	public void setShowHead(boolean head) {
		showHead = head;
	}

	public void setDataset(Dataset d) {
		data = d;
		bfGr = null;
		bfImg = null;
		repaint();
	}

	public void setDataset(Dataset d, boolean head) {
		setDataset(d);
		setShowHead(head);
	}

	public void paint(Graphics g) {
		if (bfImg != null) {
			g.translate(-transx, -transy);
			g.drawImage(bfImg, 0, 0, this);
		} else {
			update(g);
			g.translate(0, 0);
			g.drawImage(bfImg, 0, 0, this);
		}
	}

    public void createBuffer() {
        int x = 0;

			bfImg = createImage(bfDim.width, bfDim.height);
			bfGr = bfImg.getGraphics();

		    bfGr.setColor(Color.blue);

    		Dimension d = size();
    		bfGr.drawRect(0,0, d.width - 1, d.height - 1);

            Font font = bfGr.getFont();
            FontMetrics fontMetrics = bfGr.getFontMetrics();
            rowh = fontMetrics.getHeight();

            for (c=0; c < data.colCount; c++) {
        	    displayWidth[c] = fontMetrics.stringWidth(displayName[c])+12;
        	    x += displayWidth[c]+12;
        	}

            bfDim = new Dimension(x+5, (rowh+7)*data.rowCount+20);
			bfImg = createImage(bfDim.width, bfDim.height);
			bfGr = bfImg.getGraphics();
			sheet.resizeHscrollbar();
			sheet.resizeVscrollbar();
	}

	public void update(Graphics g) {

        int x;
        int xold;
        int y;

	    if (bfGr == null) {
		    createBuffer();
    		y=0;
    		x=0;
    		if (showHead) {
    			for (c=0; c < data.colCount; c++) {
    			    xold = x;
    			    x += displayWidth[c];
    				bfGr.setColor(Color.white);
    				bfGr.fill3DRect(xold+2, y*rowh+2, displayWidth[c]-2,rowh-2, true);
    				bfGr.setColor(g.getColor().brighter());
    				bfGr.setColor(Color.darkGray);
    				bfGr.draw3DRect(xold, y*rowh, displayWidth[c], rowh, true);
    				bfGr.setColor(Color.black);
    				bfGr.drawString(data.colName[c].toString(), xold+xi, y*rowh+fonth);
    			  }
    			 y = 1;
    		}

    		for (r=0; r < data.rowCount; r++) {
    			  data.gotoRow(data.rowCount-r-1);
    			  x=0;
    			  for (c=0; c < data.colCount; c++) {
    			    xold = x;
    			    x += displayWidth[c];
    			    bfGr.setColor(Color.gray);
    				bfGr.fill3DRect(xold+2, y*rowh+2, displayWidth[c]-2, rowh-2, true);
    				bfGr.setColor(g.getColor().brighter());
    				bfGr.setColor(Color.darkGray);
    				bfGr.draw3DRect(xold, y*rowh, displayWidth[c], rowh, true);
    				bfGr.setColor(Color.white);
    				bfGr.drawString(data.row.col[c].toString(), xold+xi, y*rowh+fonth);
      			  }
    			  y++;
    		}
	    }
	paint(g);
	}
}


class DBSheet extends Panel implements DatasetComponent {

    DBPanel   panel;
    Database  db;
    String    sql;
    Dataset   ds;
	DBSheetSC content;

	Dimension size;
	boolean   head;
	Scrollbar hscrollbar;
	Scrollbar vscrollbar;

	DBSheet(Database rdbms, String query, Dimension prefSize, boolean header) {

        size = prefSize;
        head = header;

	    setSQLText(rdbms, query);
	    ds = new Dataset(db, sql);

		content = new DBSheetSC(this, ds, size, head);

		//Create horizontal scrollbar.
		hscrollbar = new Scrollbar(Scrollbar.HORIZONTAL);

		//Create vertical scrollbar.
		vscrollbar = new Scrollbar(Scrollbar.VERTICAL);

		//Add Components to the Applet.
		setLayout(new BorderLayout());
		add("Center",content);
		add("East",vscrollbar);
		add("South",hscrollbar);
		validate();
		resizeHscrollbar();
		resizeVscrollbar();
	}

	DBSheet(Dimension prefSize, boolean header) {

        size = prefSize;
        head = header;

	    setSQLText(null, null);
	    ds = null;
		content = null;


		//Create horizontal scrollbar.
		hscrollbar = new Scrollbar(Scrollbar.HORIZONTAL);

		//Create vertical scrollbar.
		vscrollbar = new Scrollbar(Scrollbar.VERTICAL);

		//Add Components to the Applet.
		setLayout(new BorderLayout());
		add("East",vscrollbar);
		add("South",hscrollbar);
		validate();
	}

    public boolean handleEvent(Event evt) {

        switch (evt.id) {
          case Event.SCROLL_LINE_UP:
          case Event.SCROLL_LINE_DOWN:
          case Event.SCROLL_PAGE_UP:
          case Event.SCROLL_PAGE_DOWN:
          case Event.SCROLL_ABSOLUTE:
            if (vscrollbar.getMaximum() == 0) {
               resizeHscrollbar();
               resizeVscrollbar();
            }

            if (evt.target == vscrollbar) {
                content.transy = ((Integer)evt.arg).intValue();
                content.repaint();
	    	    resizeHscrollbar();
		        resizeVscrollbar();
            }
            if (evt.target == hscrollbar) {
                content.transx = ((Integer)evt.arg).intValue();
                content.repaint();
//			    resizeHscrollbar();
//		        resizeVscrollbar();
            }
        }
        return super.handleEvent(evt);
    }


    //Don't call this until the canvas size is valid.
    void resizeHscrollbar() {

        int contentWidth = content.size().width;
        int bufWidth = content.bfDim.width;

//       if (contentWidth <= 0) { contentWidth = 100; }
//        if (bufWidth <= 0) { bufWidth = 400; }

        if (contentWidth <= 0) {
            return;
        }

        //Shift right for empty space
        if ((content.transx + contentWidth) > content.bfDim.width) {
            int newtx = bufWidth - contentWidth;
            if (newtx < 0) {
                newtx = 0;
            }
            content.transx = newtx;
        }

	 //draw the part of the image that starts at this x:
	hscrollbar.setValues(
		content.transx,
		//amount to scroll for a "page":
		//(int)(contentWidth * 0.9),
		(int) 50,
		//minimum image x to specify:
		0,
		//maximum image x to specify:
		bufWidth - contentWidth);

	//"visible" arg to setValues() has no effect after scrollbar is visible.
//	hscrollbar.setLineIncrement((int)45);
//	hscrollbar.setPageIncrement((int)15);
//	hscrollbar.setValues(content.transx,50,0,bufWidth - contentWidth);

		return;
    }

    //Don't call this until the canvas size is valid.
    void resizeVscrollbar() {

        int contentHeight = content.size().height;
        int bufHeight = content.bfDim.height;

 //      if (contentHeight <= 0) { contentHeight = 100; }
 //      if (bufHeight <= 0) { bufHeight = 400; }

        if (contentHeight <= 0) {
            return;
        }

        //Shift everything downward if we're displaying empty space
        //on the bottom.
        if ((content.transy + contentHeight) > bufHeight) {
            int newty = bufHeight - contentHeight;
            if (newty < 0) {
                newty = 0;
            }
            content.transy = newty;
        }

        vscrollbar.setValues(//initially draw part of image starting at this y:
                       content.transy,
                       //visible arg--amount to scroll for a "page":
                       (int)(content.rowh+content.yi)*10,
                       //minimum image y to specify:
                       0,
                       //maximum image y to specify:
                       bufHeight - contentHeight);
        vscrollbar.setLineIncrement((int)(0.2*(bufHeight - contentHeight)));
        vscrollbar.setPageIncrement((int)(0.8*(bufHeight - contentHeight)));
        vscrollbar.setValues(content.transy,(int)(0.8*(bufHeight - contentHeight)),0,
                                bufHeight - contentHeight);

        return;
    }


////////////////////////////////////////////////////////
// Implement the QueryableComponent interface methods //
////////////////////////////////////////////////////////

    public void setDBPanel(DBPanel dbPanel) {
        panel = dbPanel;
    }

    public DBPanel getDBPanel() {
        return panel;
    }

    public void hasChangedEvent() {
        panel.handleChange();
    }

    public byte getWidgetType() {
        return SHEET_TYPE;
    }

    public String getSQLText() {
        return sql;
    }

    public void setSQLText(Database rdbms, String query) {
        sql = query;
        db = rdbms;
    }

    public void refreshSQL() {

	    ds = new Dataset(db, sql);
        if (content != null) {
            remove(content);
        }
		content = new DBSheetSC(this, ds, size, head);
		add("Center",content);

//        content.setDataset(ds);

		resizeHscrollbar();
		resizeVscrollbar();
		validate();
		resizeHscrollbar();
		resizeVscrollbar();
    }

    public void refreshSQL(Database rdbms, String query) {

	    ds = new Dataset(rdbms, query);
 //       content.setDataset(ds);

        if (content != null) {
            remove(content);
        }
		content = new DBSheetSC(this, ds, size, head);
        add("Center",content);

		resizeHscrollbar();
		resizeVscrollbar();
		validate();
		resizeHscrollbar();
		resizeVscrollbar();
    }

    public Dataset getDataset() {
        return ds;
    }

    public int getRownum() {
        return content.data.rowCurrent;
    }

    public String getValue() {
        return content.data.row.col[0].toString();
    }

//////////////////////////////////////////////////////
// Implement the DatasetComponent interface methods //
//////////////////////////////////////////////////////

    public void setColumnName(int colNum, String name) {
        content.displayName[colNum] = name;
    }

    public String getColumnName(int colNum) {
        return content.displayName[colNum];
    }

    /*
     * Add sql output to the parameter String of this list.
     */

    protected String paramString() {
	    return super.paramString() + ",sql=" + getSQLText();
	}


}
