import java.util.*;
import java.io.*;

public class DSRow {
  public DataInputStream qb;
  public Object col[];
  public int numCol;
  byte colType[];
  int colSize[];

  public static final byte INT_TYPE = 127;
  public static final byte CHAR_TYPE = 96;
  public static final byte REAL_TYPE = 2;

  public DSRow(DataInputStream qbs, int numCols, byte colTypes[], int colSizes[]) {
    qb = qbs;
    numCol = numCols;
    colType = colTypes;
    colSize = colSizes;
    col = new Object[numCol];
  }

  public DSRow(DSRow old) {
    qb = old.qb;
    col = old.col;
    numCol = old.numCol;
    colType = old.colType;
    colSize = old.colSize;
  }

  public String toString() {
    byte i;
    StringBuffer out = new StringBuffer(numCol*10);

    out.append("["+col[0]);
    for (i=1; i < numCol; i++) {
        out.append(", "+col[i]);
    }
    out.append("]");
    return out.toString();
  }

  public boolean fetch() {
	try {
	    if (qb.available() < 1) {
	    	return(false);
	    }
	    for (int i=0; i < numCol; i++) {
    	  byte ct = colType[i];
	      switch (ct) {
    	 	case INT_TYPE:  {col[i] = new Integer(qb.readInt()); break;}
        	case CHAR_TYPE: {
				col[i] = new String(qb.readUTF());
				qb.skipBytes(colSize[i] - 2 - ((String) col[i]).length());
				break;
                                }
		case REAL_TYPE: {col[i] = new Float(qb.readFloat()); break;}
	      }
    	}
    } catch (IOException e) {
      	return(false);
    }

    return(true);
  }

  public int getInt(int coln) {
    return((Integer) col[coln]).intValue();
  }

  public String getString(int coln) {
    return((String) col[coln]);
  }

  public float getFloat(int coln) {
    return((Float) col[coln]).floatValue();
  }


}
