//
// This interface is designed to be used by subclasses of Component
// that wish to have available values be associated to SQL queries
// against a Database class connection
//
// If component SQL queries contain placeholder values that are
// to be dynamically replaced with values from the state of other
// components, then they should be contructed WITHOUT the SQL
// being set. These
//
//

public interface QueryableComponent {

    static final byte LIST_TYPE=0;
    static final byte CHOICE_TYPE=1;
    static final byte TEXT_FIELD_TYPE=2;
    static final byte SHEET_TYPE=3;

    void setDBPanel(DBPanel panel);

    DBPanel getDBPanel();

    void hasChangedEvent(); // Call DBPanel.handleChange()

    byte getWidgetType();

    String getSQLText();

    void setSQLText(Database rdbms, String query);

    void refreshSQL();

    void refreshSQL(Database rdbms, String query);

    Dataset getDataset();

    int getRownum();

    String getValue();

}