/*  No copyright is claimed [For this document], but the author requests the following
	information be included anywhere this code is used.
	written 1996 as part of submission for Sun's Java Cup...questions & comments happily accepted.
	Miles T. Parker, Software Development & Consulting
	Washington, DC. miles@clark.net (202) 232-1468												*/	
	
import java.awt.Graphics;
import java.awt.Font;
import java.awt.Point;
import java.awt.FontMetrics;
import java.awt.Canvas;
import java.awt.Color;

public class DrawableArgument extends Argument implements Drawable {

	public Point position;
	public boolean drawable;
	
	public Point extent;
	private protected boolean preparedForDrawing;
	
	public static Color argument_background_color = new Color(0xE0, 0xE0, 0xFF);
	public static Color argument_background_selected_color = new Color(0xFF, 0xFF, 0xC0);
	public static Font argument_font = new Font("Helvetica",Font.PLAIN,9);
	public static int argument_constraint = 150;
	
	private protected static int border = 3;
	private protected static int shift_down = 1;
	private protected static Point relative_text_position = new Point((border), (border + shift_down));
	
	public static int selected_id = 0;
	public static int lowest_point;
	
	private int text_width,text_height,leading,ascent,descent;
	private Arrow currentArrow;
	private ConstrainableDrawableText drawable_text;
	
	public DrawableArgument () {
		super();
		position = new Point(0,0); //the argument dosn't have a position till it's appropriate
		drawable = false;
		extent = new Point(0,0); //the argument dosn't have a position till it's appropriate
		preparedForDrawing = false;
	}
	
	public DrawableArgument (String text) {
		super(text);
		position = new Point(0,0); //the argument dosn't have a position till it's appropriate
		drawable = false;
		extent = new Point(0,0); //the argument dosn't have a position till it's appropriate
		preparedForDrawing = false;
	}
	
	public final Point getExtent () {return extent;}
	
	public void prepareForDrawing(Graphics g) {
		//Called as soon as we know its going to be drawn, we don't have to know the position
		
		drawable_text = new ConstrainableDrawableText(g, text, argument_font, argument_constraint);
		extent = new Point((drawable_text.getExtent().x + (border*2)),(drawable_text.getExtent().y + (border*2)));
		preparedForDrawing = true;
	}
	
	public void paint (Graphics g) {
		if (drawable) {
			if (!preparedForDrawing) prepareForDrawing(g);

			if (selected_id != this.id) {
				g.setColor(argument_background_color);
			}
			else {
				g.setColor(argument_background_selected_color);
			}
			g.fillRect(position.x, position.y, extent.x, extent.y);

			g.setColor(Color.black);
			g.drawRect(position.x, position.y, extent.x, extent.y);
			
			drawable_text.paint(g, position.x + relative_text_position.x, position.y + relative_text_position.y);
		}
	}
	
	public boolean within (int x, int y) {
		if ((position.x <= x) && (position.y <= y)){
			if ((position.x + extent.x >= x) && (position.y + extent.y >= y)){
				return true;
			}
			else {
				return false;
			}
		}
		else {
			return false;
		}
	}
	
	public void select () {
		selected_id = this.id;  //only one Argument may be selected at a time
	}
}
