import java.awt.*;
import java.applet.Applet;
import java.applet.*;
import java.util.Random;

public class dbViewer extends Applet {

	/* These are all of the colours used in the display. */
	Color level1Colours[] = new Color[7];
	String level1Strings[] = new String[7];
	Color level2Colours[][] = new Color[7][13];
	String level2Strings[][] = new String[7][13];
	Color level3Colours[][][] = new Color[7][13][15];
	String level3Strings[][][] = new String[7][13][15];

	Color lightBlue = new Color(200,200,255);

	/* These values indicate the number of elements in the tree at each level. */
	int numLevel1s = 6;
	int numLevel2s[] = new int[6];
	int numLevel3s[][] = new int[6][13];

	/* The smooth transition colours. */
	Color histFadeColours[];
	Color textFadeColours[];

	/* Operational flags. */
	boolean smoothTransition = true;
	boolean runningDemo = false;
	boolean processingEvent = false;

	/* The demo thread. */
	demoThread myThread;

	/* Pointers into the data structure for the vertical and horizontal axes. */
	boolean Veach, VoneOf, VtheTotal;
	int VtheOne;
	boolean Heach, HoneOf, HtheTotal;
	int HtheOne;

	/* Flag to prevent printing an empty table. */
	boolean valuesNotComputed = true;

	/* Temporary variables. */
	int i,j,k,l;

	/* Constants for various actions. */
	final int transSteps = 30;
	final int transDelay = 10;
	final int burstDelay = 50;

	/* The graphics context. */
	Graphics gg;

	/* Unused...
	Rectangle tempRect = new Rectangle(0,0,0,0);
	*/

	/* These are all of the constants used to index into the data set */
	int GlobalZone = 0;
		int NorthAmerica = 0;
			int Canada = 0;
			int USAtlantic = 1;
			int USPacific = 2;
			int USMidwest = 3;
			int USSouth = 4;
			int Mexico = 5;
		int Europe = 1;
			int UK = 0;
			int France = 1;
			int Germany = 2;
			int Italy = 3;
			int Scandanavia = 4;
		int AsiaPacific = 2;
			int Japan = 0;
			int China = 1;
			int HongKong = 2;
			int Australia = 3;

	int Category = 1;
		int Luxury = 0;
			int CatAmeriLux = 0;
			int CatEuroLux = 1;
			int CatNipponLux = 2;
		int SportsCar = 1;
			int CatAmeriSport = 0;
			int CatEuroSport = 1;
			int CatNipponSport = 2;
		int Economy = 2;
			int CatAmerEcon = 0;
			int CatEurEcon = 1;
			int CatNipponEcon = 2;
		int Utility = 3;
			int CatAmerUtil = 0;
			int CatEurUtil = 1;
			int CatNipponUtil = 2;

	int Line = 2;
		int American = 0;
			int LineAmeriLux = 0;
			int LineAmeriSport = 1;
			int LineAmerEcon = 2;
			int LineAmerUtil = 3;
		int European = 1;
			int LineEuroLux = 0;
			int LineEuroSport = 1;
			int LineEurEcon = 2;
			int LineEurUtil = 3;
		int Japanese = 2;
			int LineNipponLux = 0;
			int LineNipponSport = 1;
			int LineNipponEcon = 2;
			int LineNipponUtil = 3;

	int Quarter = 3;

	int Month = 4;

	int Week  = 5;

	/* Level down into the (tree-shaped) data set. */
	int Vlevel = 0;
	int Hlevel = 0;

	/* Choices made at each level while going down into the data set. */
	int VChoice0 = 0;
	int HChoice0 = 0;
	int VChoice1 = 0;
	int HChoice1 = 0;
	int VChoice2 = 0;
	int HChoice2 = 0;

	/* These are constants specifying the layout of the screen image. */
	final int DemoT = 250;
	final int DemoL = 20;
	final int DemoR = 80;
	final int DemoB = 280;

	final int transTypeT = 290;
	final int transTypeL = 20;
	final int transTypeR = 80;
	final int transTypeB = 320;

	final int VWidth = 10;
	final int VSpacing = 10;
	final int VRootL = 3;
	final int VRootT = 110;
	final int VRootWidth = 7;
	final int VRootHeight = 40;
	final int VRootR = VRootL+VRootWidth;
	final int VRootB = VRootT+VRootHeight;
	final int VBlocksT = 30;
	final int VBlocksB = 230;
	final int VBlock1L = VRootL+VRootWidth+VSpacing;
	final int VBlock1R = VBlock1L+VWidth;
	final int VBlock2L = VBlock1R+VSpacing;
	final int VBlock2R = VBlock2L+VWidth;
	final int VBlock3L = VBlock2R+VSpacing;
	final int VBlock3R = VBlock3L+4*VWidth;

	final int HHeight = 10;
	final int HSpacing = 10;
	final int HRootL = 260;
	final int HRootT = 320;
	final int HRootWidth = 80;
	final int HRootHeight = 8;
	final int HRootR = HRootL+HRootWidth;
	final int HRootB = HRootT+HRootHeight;
	final int HBlocksL = VBlock3R;
	final int HBlocksR = 500;
	final int HBlock3T = VBlocksB;
	final int HBlock3B = HBlock3T+4*HHeight;
	final int HBlock2T = HBlock3B+HSpacing;
	final int HBlock2B = HBlock2T+HHeight;
	final int HBlock1T = HBlock2B+HSpacing;
	final int HBlock1B = HBlock1T+HHeight;

	final int DataT = VBlocksT;
	final int DataL = VBlock3R;
	final int DataB = HBlock3T;
	final int DataR = HBlocksR;

	final int VTotalT = 2;
	final int VTotalL = VBlock3L;
	final int VTotalB = DataT;
	final int VTotalR = VBlock3R;

	final int HTotalT = DataB;
	final int HTotalL = HBlocksR;
	final int HTotalB = HBlock3B;
	final int HTotalR = HBlocksR+40;

	/* These variables are used in condensing the 3-dimensional data set down to 1- or 2-D. */
	int VDim, VRange, HDim, HRange;

	/* This is the 3-D array which holds the sample data set. */
	int allData[][][] = new int[12][15][52];

	/* This is the array into which the data set is condensed for display. */
	int displayData[][] = new int[52][52];

	private void drawVRootBlock() {

		gg.setPaintMode();
		gg.setColor(Color.black);
		gg.fillRect(VRootL, VRootT, VRootWidth, VRootHeight);
	}

	/* Draw the horizontal root block. */
	private void drawHRootBlock() {

		gg.setPaintMode();
		gg.setColor(Color.black);
		gg.fillRect(HRootL, HRootT, HRootWidth, HRootHeight);
	}

	/* Draw the trapezoid-shape between one level and the next for the vertical axis. */
	private void drawVExp(int fromLevel, int fromField, int numFields, int toLevel, Color theColour) {

		Polygon myPoly = new Polygon();

		if (fromLevel == 0) {
			myPoly.addPoint(VRootL+VRootWidth,VRootT);
			myPoly.addPoint(VRootL+VRootWidth,VRootT+VRootHeight);
		} else if (fromLevel == 1) {
			myPoly.addPoint(VBlock1R,VBlocksT+(fromField*(VBlocksB-VBlocksT))/numFields);
			myPoly.addPoint(VBlock1R,VBlocksT+((fromField+1)*(VBlocksB-VBlocksT))/numFields);
		} else if (fromLevel == 2) {
			myPoly.addPoint(VBlock2R,VBlocksT+(fromField*(VBlocksB-VBlocksT))/numFields);
			myPoly.addPoint(VBlock2R,VBlocksT+((fromField+1)*(VBlocksB-VBlocksT))/numFields);
		}
		if (toLevel == 1) {
			myPoly.addPoint(VBlock1L,VBlocksB);
			myPoly.addPoint(VBlock1L,VBlocksT);
		} else if (toLevel == 2) {
			myPoly.addPoint(VBlock2L,VBlocksB);
			myPoly.addPoint(VBlock2L,VBlocksT);
		} else if (toLevel == 3) {
			myPoly.addPoint(VBlock3L,VBlocksB);
			myPoly.addPoint(VBlock3L,VBlocksT);
		};
		myPoly.addPoint(myPoly.xpoints[0], myPoly.ypoints[0]);
		gg.setColor(theColour);
		gg.fillPolygon(myPoly);
		gg.setColor(Color.black);
		gg.drawPolygon(myPoly);
	}

	/* Draw the trapezoid-shape between one level and the next for the horizontal axis. */
	private void drawHExp(int fromLevel, int fromField, int numFields, int toLevel, Color theColour) {

		Polygon myPoly = new Polygon();

		if (fromLevel == 0) {
			myPoly.addPoint(HRootL,HRootT);
			myPoly.addPoint(HRootL+HRootWidth,HRootT);
		} else if (fromLevel == 1) {
			myPoly.addPoint(HBlocksL+(fromField*(HBlocksR-HBlocksL))/numFields,HBlock1T);
			myPoly.addPoint(HBlocksL+((fromField+1)*(HBlocksR-HBlocksL))/numFields,HBlock1T);
		} else if (fromLevel == 2) {
			myPoly.addPoint(HBlocksL+(fromField*(HBlocksR-HBlocksL))/numFields,HBlock2T);
			myPoly.addPoint(HBlocksL+((fromField+1)*(HBlocksR-HBlocksL))/numFields,HBlock2T);
		}
		if (toLevel == 1) {
			myPoly.addPoint(HBlocksR,HBlock1B);
			myPoly.addPoint(HBlocksL,HBlock1B);
		} else if (toLevel == 2) {
			myPoly.addPoint(HBlocksR,HBlock2B);
			myPoly.addPoint(HBlocksL,HBlock2B);
		} else if (toLevel == 3) {
			myPoly.addPoint(HBlocksR,HBlock3B);
			myPoly.addPoint(HBlocksL,HBlock3B);
		};
		myPoly.addPoint(myPoly.xpoints[0], myPoly.ypoints[0]);
		gg.setColor(theColour);
		gg.fillPolygon(myPoly);
		gg.setColor(Color.black);
		gg.drawPolygon(myPoly);
	}

	/* Draw one axis column -- at the given level in the given colours. */
	private void drawVBlock(int inLevel, int numColours, Color[] inColours) {

		if (inLevel == 1) {
			for (i=0;i<numColours;i++) {
				gg.setColor(inColours[i]);
				if (i == (numColours-1)) {
					gg.fillRect(VBlock1L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock1R-VBlock1L,VBlocksB-(VBlocksT+i*(VBlocksB-VBlocksT)/numColours));
				} else {
					gg.fillRect(VBlock1L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock1R-VBlock1L,(VBlocksB-VBlocksT)/numColours);
				}	
		}
			for (i=0;i<numColours;i++) {
				gg.setColor(Color.black);
				if (i == (numColours-1)) {
					gg.drawRect(VBlock1L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock1R-VBlock1L,VBlocksB-(VBlocksT+i*(VBlocksB-VBlocksT)/numColours));
				} else {
					gg.drawRect(VBlock1L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock1R-VBlock1L,(VBlocksB-VBlocksT)/numColours);
				}	
			}
		} else if (inLevel == 2) {
			for (i=0;i<numColours;i++) {
				gg.setColor(inColours[i]);
				if (i == (numColours-1)) {
					gg.fillRect(VBlock2L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock2R-VBlock2L,VBlocksB-(VBlocksT+i*(VBlocksB-VBlocksT)/numColours));
				} else {
					gg.fillRect(VBlock2L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock2R-VBlock2L,(VBlocksB-VBlocksT)/numColours);
				}
			}
			for (i=0;i<numColours;i++) {
				gg.setColor(Color.black);
				if (i == (numColours-1)) {
					gg.drawRect(VBlock2L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock2R-VBlock2L,VBlocksB-(VBlocksT+i*(VBlocksB-VBlocksT)/numColours));
				} else {
					gg.drawRect(VBlock2L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock2R-VBlock2L,(VBlocksB-VBlocksT)/numColours);
				}
			}
		}
	}

	/* Draw one axis row -- at the given level in the given colours. */
	/* This is for a textless column of colour blocks. */
	private void drawHBlock(int inLevel, int numColours, Color[] inColours) {

		if (inLevel == 1) {
			for (i=0;i<numColours;i++) {
				gg.setColor(inColours[i]);
				if (i == (numColours-1)) {
					gg.fillRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock1T,HBlocksR-(HBlocksL+i*(HBlocksR-HBlocksL)/numColours),HBlock1B-HBlock1T);
				} else {
					gg.fillRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock1T,(HBlocksR-HBlocksL)/numColours,HBlock1B-HBlock1T);
				}	
		}
			for (i=0;i<numColours;i++) {
				gg.setColor(Color.black);
				if (i == (numColours-1)) {
					gg.drawRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock1T,HBlocksR-(HBlocksL+i*(HBlocksR-HBlocksL)/numColours),HBlock1B-HBlock1T);
				} else {
					gg.drawRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock1T,(HBlocksR-HBlocksL)/numColours,HBlock1B-HBlock1T);
				}	
			}
		} else if (inLevel == 2) {
			for (i=0;i<numColours;i++) {
				gg.setColor(inColours[i]);
				if (i == (numColours-1)) {
					gg.fillRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock2T,HBlocksR-(HBlocksL+i*(HBlocksR-HBlocksL)/numColours),HBlock2B-HBlock2T);
				} else {
					gg.fillRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock2T,(HBlocksR-HBlocksL)/numColours,HBlock2B-HBlock2T);
				}
			}
			for (i=0;i<numColours;i++) {
				gg.setColor(Color.black);
				if (i == (numColours-1)) {
					gg.drawRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock2T,HBlocksR-(HBlocksL+i*(HBlocksR-HBlocksL)/numColours),HBlock2B-HBlock2T);
				} else {
					gg.drawRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock2T,(HBlocksR-HBlocksL)/numColours,HBlock2B-HBlock2T);
				}
			}
		}
	}

	/* Special axis column for weeks. */
	/* This is for a textless row of colour blocks. */
	private void drawVViewingWeeks(int numColours, Color[] inColours, String[] inStrings) {

		int lineL;
		gg.setColor(Color.white);
		gg.fillRect(VBlock3L,VBlocksT,VBlock3R-VBlock3L,VBlocksB-VBlocksT);
		gg.setColor(Color.black);
		gg.drawRect(VBlock3L,VBlocksT,VBlock3R-VBlock3L,VBlocksB-VBlocksT);
		for (i=0;i<52;i++) {
			if ((i==0)||(i==13)||(i==26)||(i==39)) {
				lineL = VBlock3L;
			} else if ((i==4)||(i==8)||(i==17)||(i==22)||(i==30)||(i==35)||(i==43)||(i==48)) {
				lineL = VBlock3R-20;
			} else {
				lineL = VBlock3R-10;
			}
			gg.drawLine(lineL,VBlocksT+((i*(VBlocksB-VBlocksT))/52),VBlock3R,VBlocksT+((i*(VBlocksB-VBlocksT))/52));
		}
		gg.setColor(Color.black);
		if (VtheTotal) {
			gg.fillRect(VTotalR-4,VTotalT,4,4);
		} else if (Veach) {
			gg.fillRect(VTotalR-4,(VTotalB+VTotalT)/2,4,4);
		}
	}

	/* Special axis row for weeks. */
	private void drawHViewingWeeks(int numColours, Color[] inColours, String[] inStrings) {

		int lineB;
		gg.setColor(Color.white);
		gg.fillRect(HBlocksL,HBlock3T,HBlocksR-HBlocksL,HBlock3B-HBlock3T);
		gg.setColor(Color.black);
		gg.drawRect(HBlocksL,HBlock3T,HBlocksR-HBlocksL,HBlock3B-HBlock3T);
		for (i=0;i<52;i++) {
			if ((i==0)||(i==13)||(i==26)||(i==39)) {
				lineB = HBlock3B;
			} else if ((i==4)||(i==8)||(i==17)||(i==22)||(i==30)||(i==35)||(i==43)||(i==48)) {
				lineB = HBlock3T+20;
			} else {
				lineB = HBlock3T+10;
			}
			gg.drawLine(HBlocksL+((i*(HBlocksR-HBlocksL))/52),HBlock3T,HBlocksL+((i*(HBlocksR-HBlocksL))/52),lineB);
		}
		gg.setColor(Color.black);
		if (HtheTotal) {
			gg.fillRect(HTotalR-4,HTotalT,4,4);
		} else if (Heach) {
			gg.fillRect(HTotalR-4,(HTotalB+HTotalT)/2,4,4);
		}
	}

	/* Draw the axis column closest to the data field; contains text labels. */
	private void drawVViewingBlock(int numColours, Color[] inColours, String[] inStrings) {

		for (i=0;i<numColours;i++) {
			gg.setColor(inColours[i]);
			if (i == (numColours-1)) {
				gg.fillRect(VBlock3L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock3R-VBlock3L,VBlocksB-(VBlocksT+i*(VBlocksB-VBlocksT)/numColours));
			} else {
				gg.fillRect(VBlock3L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock3R-VBlock3L,(VBlocksB-VBlocksT)/numColours);
			}
		}
		for (i=0;i<numColours;i++) {
			gg.setColor(Color.black);
			if (i == (numColours-1)) {
				gg.drawRect(VBlock3L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock3R-VBlock3L,VBlocksB-(VBlocksT+i*(VBlocksB-VBlocksT)/numColours));
			} else {
				gg.drawRect(VBlock3L,VBlocksT+i*(VBlocksB-VBlocksT)/numColours,VBlock3R-VBlock3L,(VBlocksB-VBlocksT)/numColours);
			}
		}
		if (((VBlocksB-VBlocksT)/numColours) > 10) {
			for (i=0;i<numColours;i++) {
				if (inStrings[i].length() > 3) {
					gg.drawString(inStrings[i],VBlock3L+3,VBlocksT+(((2*i+1)*(VBlocksB-VBlocksT))/2)/numColours+5);
				} else {
					gg.drawString(inStrings[i],VBlock3L+6,VBlocksT+(((2*i+1)*(VBlocksB-VBlocksT))/2)/numColours+5);
				}
			}
		}
		gg.setColor(Color.black);
		if (VtheTotal) {
			gg.fillRect(VTotalR-4,VTotalT,4,4);
		} else if (Veach) {
			gg.fillRect(VTotalR-4,(VTotalB+VTotalT)/2,4,4);
		} else if (VoneOf) {
			gg.fillRect(VBlock3R-4,VBlocksT+VtheOne*(VBlocksB-VBlocksT)/numColours,4,4);
		}
	}

	/* Draw the axis row closest to the data field; contains text labels. */
	private void drawHViewingBlock(int numColours, Color[] inColours, String[] inStrings) {

		char oneChar[] = new char[1];

		for (i=0;i<numColours;i++) {
			gg.setColor(inColours[i]);
			if (i == (numColours-1)) {
				gg.fillRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock3T,HBlocksR-(HBlocksL+i*(HBlocksR-HBlocksL)/numColours),HBlock3B-HBlock3T);
			} else {
				gg.fillRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock3T,(HBlocksR-HBlocksL)/numColours,HBlock3B-HBlock3T);
			}
		}
		for (i=0;i<numColours;i++) {
			gg.setColor(Color.black);
			if (i == (numColours-1)) {
				gg.drawRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock3T,HBlocksR-(HBlocksL+i*(HBlocksR-HBlocksL)/numColours),HBlock3B-HBlock3T);
			} else {
				gg.drawRect(HBlocksL+i*(HBlocksR-HBlocksL)/numColours,HBlock3T,(HBlocksR-HBlocksL)/numColours,HBlock3B-HBlock3T);
			}
		}
		if (((HBlocksR-HBlocksL)/numColours) > 33) {
			for (i=0;i<numColours;i++) {
				gg.drawString(inStrings[i],HBlocksL+(((2*i+1)*(HBlocksR-HBlocksL)/numColours))/2-((((inStrings[i]).length())*5)/2),HBlock3T+((HBlock3B-HBlock3T)/2)+4);
			}
		} else if (((HBlocksR-HBlocksL)/numColours) > 10) {
			for (i=0;i<numColours;i++) {
				inStrings[i].getChars(0,1,oneChar,0);
				gg.drawChars(oneChar,0,1,HBlocksL+(((2*i+1)*(HBlocksR-HBlocksL)/numColours))/2-3,HBlock3T+((HBlock3B-HBlock3T)/2)-6);
				if (inStrings[i].length() > 1) {
					inStrings[i].getChars(1,2,oneChar,0);
					gg.drawChars(oneChar,0,1,HBlocksL+(((2*i+1)*(HBlocksR-HBlocksL)/numColours))/2-3,HBlock3T+((HBlock3B-HBlock3T)/2+4));
				}
				if (inStrings[i].length() > 2) {
					inStrings[i].getChars(2,3,oneChar,0);
					gg.drawChars(oneChar,0,1,HBlocksL+(((2*i+1)*(HBlocksR-HBlocksL)/numColours))/2-3,HBlock3T+((HBlock3B-HBlock3T)/2)+14);
				}
			}
		}
		gg.setColor(Color.black);
		if (HtheTotal) {
			gg.fillRect(HTotalR-4,HTotalT,4,4);
		} else if (Heach) {
			gg.fillRect(HTotalR-4,(HTotalB+HTotalT)/2,4,4);
		} else if (HoneOf) {
			gg.fillRect(HBlocksL+HtheOne*(HBlocksR-HBlocksL)/numColours,HBlock3T,4,4);
		}
	}

	/* This draws the 'Total' box at the top of the axis columns. */
	private void drawVTotal() {

		gg.setColor(new Color(180,180,180));
		gg.fillRect(VTotalL,VTotalT,VTotalR-VTotalL,VTotalB-VTotalT);
		gg.setColor(Color.black);
		gg.drawRect(VTotalL,VTotalT,VTotalR-VTotalL,VTotalB-VTotalT);
		gg.drawLine(VTotalL,(VTotalB+VTotalT)/2,VTotalR,(VTotalB+VTotalT)/2);
		gg.drawString("Total",VTotalL+5,(VTotalB+VTotalT)/2-2);
		gg.drawString("All",VTotalL+5,VTotalB-2);
	}

	/* This draws the 'Total' box at the right of the axis rows. */
	private void drawHTotal() {

		gg.setColor(new Color(180,180,180));
		gg.fillRect(HTotalL,HTotalT,HTotalR-HTotalL,HTotalB-HTotalT);
		gg.setColor(Color.black);
		gg.drawRect(HTotalL,HTotalT,HTotalR-HTotalL,HTotalB-HTotalT);
		gg.drawLine(HTotalL,(HTotalB+HTotalT)/2,HTotalR,(HTotalB+HTotalT)/2);
		gg.drawString("Total",HTotalL+5,(HTotalB+HTotalT)/2-4);
		gg.drawString("All",HTotalL+5,HTotalB-4);
	}

	/* This is the monster routine which condenses the whole data set into the displayed set. */
	/* It prunes and sums columns and rows of data as required. */
	private void computeValues() {

		if (valuesNotComputed) {		/* Generate values first time through. */
			int correctionValue = 0;
			Random myRandom = new Random();
			int baseMult = (new Float(myRandom.nextFloat() * 8)).intValue() + 1;
			for (i=0;i<12;i++) {
				for (j=0;j<15;j++) {
					if (j < 6) {
						if ((j == 1) && (i > 7)) {
							correctionValue = 50;
						} else if (j == 5) {
							if (k < 2) {
								correctionValue = 50;
							} else if (k < 4) {
								correctionValue = 250;
							}
						} else {
							correctionValue = 200;
						}
					} else if (j < 11) {
						if ((i < 4) || (i > 7)) {
							correctionValue = 50;
						} else {
							correctionValue = 150;
						}
					} else {
						correctionValue = 120;
					}
					for (k=0;k<52;k++) {
						allData[i][j][k] = correctionValue + 100*baseMult + baseMult*k + (new Double(50*baseMult*myRandom.nextGaussian())).intValue();
					}
				}
			}
			valuesNotComputed = false;
		}
		/* VDim and HDim indicate which of the 3 data dimensions is being displayed on the vertical */
		/* and horizontal axes, respectively.  VRange and HRange indicate the number of values at   */
		/* the given level in that dimension. */
		if ((Vlevel == 0)||(VChoice1 == GlobalZone)) {
			VDim = 1;
			VRange = 15;
		} else if ((VChoice1 == Category)||(VChoice1 == Line)) {
			VDim = 0;
			VRange = 12;
		} else {
			VDim = 2;
			VRange = 52;
		}
		if ((Hlevel == 0)||(HChoice1 == Category)||(HChoice1 == Line)) {
			HDim = 0;
			HRange = 12;
		} else if (HChoice1 == GlobalZone) {
			HDim = 1;
			HRange = 15;
		} else {
			HDim = 2;
			HRange = 52;
		}
		/* The following block of code collapses the unused dimension(s) of the data by doing sums of */
		/* rows and columns. */
		if (VDim == 0) {
			if (HDim == 0) {
				for (i=0;i<12;i++) {
					for (j=0;j<12;j++) {
						displayData[i][j] = 0;
						if (i == j) {
							for (k=0;k<15;k++) {
								for (l=0;l<52;l++) {
									displayData[i][j] += allData[i][k][l];
								}
							}
						}
					}
				}
			} else if (HDim == 1) {
				for (i=0;i<12;i++) {
					for (j=0;j<15;j++) {
						displayData[i][j] = 0;
						for (k=0;k<52;k++) {
							displayData[i][j] += allData[i][j][k];
						}
					}
				}
			} else {
				for (i=0;i<12;i++) {
					for (j=0;j<52;j++) {
						displayData[i][j] = 0;
						for (k=0;k<15;k++) {
							displayData[i][j] += allData[i][k][j];
						}
					}
				}
			}
		} else if (VDim == 1) {
			if (HDim == 0) {
				for (i=0;i<15;i++) {
					for (j=0;j<12;j++) {
						displayData[i][j] = 0;
						for (k=0;k<52;k++) {
							displayData[i][j] += allData[j][i][k];
						}
					}
				}
			} else if (HDim == 1) {
				for (i=0;i<15;i++) {
					for (j=0;j<15;j++) {
						displayData[i][j] = 0;
						if (i == j) {
							for (k=0;k<12;k++) {
								for (l=0;l<52;l++) {
									displayData[i][j] += allData[k][i][l];
								}
							}
						}
					}
				}
			} else {
				for (i=0;i<15;i++) {
					for (j=0;j<52;j++) {
						displayData[i][j] = 0;
						for (k=0;k<12;k++) {
							displayData[i][j] += allData[k][i][j];
						}
					}
				}
			}
		} else {
			if (HDim == 0) {
				for (i=0;i<52;i++) {
					for (j=0;j<12;j++) {
						displayData[i][j] = 0;
						for (k=0;k<15;k++) {
							displayData[i][j] += allData[j][k][i];
						}
					}
				}
			} else if (HDim == 1) {
				for (i=0;i<52;i++) {
					for (j=0;j<15;j++) {
						displayData[i][j] = 0;
						for (k=0;k<12;k++) {
							displayData[i][j] += allData[k][j][i];
						}
					}
				}
			} else {
				for (i=0;i<52;i++) {
					for (j=0;j<52;j++) {
						displayData[i][j] = 0;
						if (i == j) {
							for (k=0;k<12;k++) {
								for (l=0;l<15;l++) {
									displayData[i][j] += allData[k][l][i];
								}
							}
						}
					}
				}
			}
		}
		/* The following block of code either sums or shifts data as indicated by the axis choices */
		/* made by the user.  First the vertical axis is handled... */
		if (VDim == 0) {
			if (Vlevel == 1) {
				if (VChoice1 == Category) {
					for (i=0;i<4;i++) {
						for (j=0;j<HRange;j++) {
							displayData[i][j] = displayData[i][j] + displayData[i+4][j] + displayData[i+8][j];
						}
					}
					VRange = 4;
				} else if (VChoice1 == Line) {
					for (i=0;i<3;i++) {
						for (j=0;j<HRange;j++) {
							displayData[i][j] = displayData[(i*4)][j] + displayData[(i*4)+1][j] + displayData[(i*4)+2][j] + displayData[(i*4)+3][j];
						}
					}
					VRange = 3;
				}
			} else if (Vlevel == 2) {
				if (VChoice1 == Category) {
					if (VChoice2 == Luxury) {
						for (j=0;j<HRange;j++) {
							displayData[1][j] = displayData[4][j];
							displayData[2][j] = displayData[8][j];
						}
					} else if (VChoice2 == SportsCar) {
						for (j=0;j<HRange;j++) {
							displayData[0][j] = displayData[1][j];
							displayData[1][j] = displayData[5][j];
							displayData[2][j] = displayData[9][j];
						}
					} else if (VChoice2 == Economy) {
						for (j=0;j<HRange;j++) {
							displayData[0][j] = displayData[2][j];
							displayData[1][j] = displayData[6][j];
							displayData[2][j] = displayData[10][j];
						}
					} else if (VChoice2 == Utility) {
						for (j=0;j<HRange;j++) {
							displayData[0][j] = displayData[3][j];
							displayData[1][j] = displayData[7][j];
							displayData[2][j] = displayData[11][j];
						}
					}
					VRange = 3;
				} else if (VChoice1 == Line) {
					if (VChoice2 == American) {
					} else if (VChoice2 == European) {
						for (j=0;j<HRange;j++) {
							displayData[0][j] = displayData[4][j];
							displayData[1][j] = displayData[5][j];
							displayData[2][j] = displayData[6][j];
							displayData[3][j] = displayData[7][j];
						}
					} else if (VChoice2 == Japanese) {
						for (j=0;j<HRange;j++) {
							displayData[0][j] = displayData[8][j];
							displayData[1][j] = displayData[9][j];
							displayData[2][j] = displayData[10][j];
							displayData[3][j] = displayData[11][j];
						}
					}
					VRange = 4;
				}
			}
		} else if (VDim == 1) {
			if (Vlevel == 0) {
				for (j=0;j<HRange;j++) {
					for (i=1;i<VRange;i++) {
						displayData[0][j] += displayData[i][j];
					}
				}
				VRange = 1;
			} else if (Vlevel == 1) {
				if (VChoice1 == GlobalZone) {
					for (j=0;j<HRange;j++) {
						for (i=1;i<numLevel3s[GlobalZone][NorthAmerica];i++) {
							displayData[0][j] += displayData[i][j];
						}
						displayData[1][j] = 0;
						for (i=0;i<numLevel3s[GlobalZone][Europe];i++) {
							displayData[1][j] += displayData[i+numLevel3s[GlobalZone][NorthAmerica]][j];
						}
						displayData[2][j] = 0;
						for (i=0;i<numLevel3s[GlobalZone][AsiaPacific];i++) {
							displayData[2][j] += displayData[numLevel3s[GlobalZone][Europe]+numLevel3s[GlobalZone][NorthAmerica]+i][j];
						}
					}
				}
				VRange = 3;
			} else if (Vlevel == 2) {
				if (VChoice1 == GlobalZone) {
					if (VChoice2 == NorthAmerica) {
						VRange = numLevel3s[GlobalZone][NorthAmerica];
					} else if (VChoice2 == Europe) {
						for (j=0;j<HRange;j++) {
							for (i=0;i<numLevel3s[GlobalZone][Europe];i++) {
								displayData[i][j] = displayData[i+numLevel3s[GlobalZone][NorthAmerica]][j];
							}
						}
						VRange = numLevel3s[GlobalZone][Europe];
					} else if (VChoice2 == AsiaPacific) {
						for (j=0;j<HRange;j++) {
							for (i=0;i<numLevel3s[GlobalZone][AsiaPacific];i++) {
								displayData[i][j] = displayData[i+numLevel3s[GlobalZone][NorthAmerica]+numLevel3s[GlobalZone][Europe]][j];
							}
						}
						VRange = numLevel3s[GlobalZone][AsiaPacific];
					}
				}
			}
		} else {
			if (Vlevel == 1) {
				if (VChoice1 == Quarter) {
					for (j=0;j<HRange;j++) {
						for (i=1;i<numLevel3s[Quarter][0];i++) {
							displayData[0][j] += displayData[i][j];
						}
						displayData[1][j] = displayData[numLevel3s[Quarter][0]][j];
						displayData[2][j] = displayData[2*numLevel3s[Quarter][0]][j];
						displayData[3][j] = displayData[3*numLevel3s[Quarter][0]][j];
						for (i=1;i<numLevel3s[Quarter][0];i++) {
							displayData[1][j] += displayData[i+numLevel3s[Quarter][0]][j];
							displayData[2][j] += displayData[i+2*numLevel3s[Quarter][0]][j];
							displayData[3][j] += displayData[i+3*numLevel3s[Quarter][0]][j];
						}
					}
					VRange = 4;
				} else if (VChoice1 == Month) {
					for (j=0;j<HRange;j++) {
						for (i=1;i<numLevel3s[Month][0];i++) {
							displayData[0][j] += displayData[i][j];
						}
						l = numLevel3s[Month][0];
						for (k=1;k<numLevel2s[Month];k++) {
							displayData[k][j] = displayData[l][j];
							for (i=1;i<numLevel3s[Month][k];i++) {
								displayData[k][j] += displayData[l+i][j];
							}
							l += numLevel3s[Month][k];
						}
					}
					VRange = 12;
				}
			} else if (Vlevel == 2) {
				if (VChoice1 == Quarter) {
					if (VChoice2 == 0) {
					} else if (VChoice2 == 1) {
						for (j=0;j<HRange;j++) {
							for (i=0;i<13;i++) {
								displayData[i][j] = displayData[i+13][j];
							}
						}
					} else if (VChoice2 == 2) {
						for (j=0;j<HRange;j++) {
							for (i=0;i<13;i++) {
								displayData[i][j] = displayData[i+26][j];
							}
						}
					} else if (VChoice2 == 3) {
						for (j=0;j<HRange;j++) {
							for (i=0;i<13;i++) {
								displayData[i][j] = displayData[i+39][j];
							}
						}
					}
					VRange = 13;
				} else if (VChoice1 == Month) {
					k = 0;
					l = 0;
					while (k < VChoice2) {
						l += numLevel3s[Month][k];
						k++;
					};
					for (j=0;j<HRange;j++) {
						for (i=0;i<4;i++) {
							displayData[i][j] = displayData[i+l][j];
						}
						if (VChoice2 != 11)
							displayData[4][j] = displayData[4+l][j];
					}
					VRange = numLevel3s[Month][k];
				}
			}
		}
		/* ... then the horizontal axis is done. */
		if (HDim == 0) {
			if (Hlevel == 0) {
				for (j=0;j<VRange;j++) {
					for (i=1;i<HRange;i++) {
						displayData[j][0] += displayData[j][i];
					}
				}
				HRange = 1;
			} else if (Hlevel == 1) {
				if (HChoice1 == Category) {
					for (i=0;i<4;i++) {
						for (j=0;j<VRange;j++) {
							displayData[j][i] = displayData[j][i] + displayData[j][i+4] + displayData[j][i+8];
						}
					}
					HRange = 4;
				} else if (HChoice1 == Line) {
					for (i=0;i<3;i++) {
						for (j=0;j<VRange;j++) {
							displayData[j][i] = displayData[j][(i*4)] + displayData[j][(i*4)+1] + displayData[j][(i*4)+2] + displayData[j][(i*4)+3];
						}
					}
					HRange = 3;
				}
			} else if (Hlevel == 2) {
				if (HChoice1 == Category) {
					if (HChoice2 == Luxury) {
						for (j=0;j<VRange;j++) {
							displayData[j][1] = displayData[j][4];
							displayData[j][2] = displayData[j][8];
						}
					} else if (HChoice2 == SportsCar) {
						for (j=0;j<VRange;j++) {
							displayData[j][0] = displayData[j][1];
							displayData[j][1] = displayData[j][5];
							displayData[j][2] = displayData[j][9];
						}
					} else if (HChoice2 == Economy) {
						for (j=0;j<VRange;j++) {
							displayData[j][0] = displayData[j][2];
							displayData[j][1] = displayData[j][6];
							displayData[j][2] = displayData[j][10];
						}
					} else if (HChoice2 == Utility) {
						for (j=0;j<VRange;j++) {
							displayData[j][0] = displayData[j][3];
							displayData[j][1] = displayData[j][7];
							displayData[j][2] = displayData[j][11];
						}
					}
					HRange = 3;
				} else if (HChoice1 == Line) {
					if (HChoice2 == American) {
					} else if (HChoice2 == European) {
						for (j=0;j<VRange;j++) {
							displayData[j][0] = displayData[j][4];
							displayData[j][1] = displayData[j][5];
							displayData[j][2] = displayData[j][6];
							displayData[j][3] = displayData[j][7];
						}
					} else if (HChoice2 == Japanese) {
						for (j=0;j<VRange;j++) {
							displayData[j][0] = displayData[j][8];
							displayData[j][1] = displayData[j][9];
							displayData[j][2] = displayData[j][10];
							displayData[j][3] = displayData[j][11];
						}
					}
					HRange = 4;
				}
			}
		} else if (HDim == 1) {
			if (Hlevel == 1) {
				if (HChoice1 == GlobalZone) {
					for (j=0;j<VRange;j++) {
						for (i=1;i<numLevel3s[GlobalZone][NorthAmerica];i++) {
							displayData[j][0] += displayData[j][i];
						}
						displayData[j][1] = 0;
						for (i=0;i<numLevel3s[GlobalZone][Europe];i++) {
							displayData[j][1] += displayData[j][i+numLevel3s[GlobalZone][NorthAmerica]];
						}
						displayData[j][2] = 0;
						for (i=0;i<numLevel3s[GlobalZone][AsiaPacific];i++) {
							displayData[j][2] += displayData[j][numLevel3s[GlobalZone][Europe]+numLevel3s[GlobalZone][NorthAmerica]+i];
						}
					}
					HRange = 3;
				}
			} else if (Hlevel == 2) {
				if (HChoice1 == GlobalZone) {
					if (HChoice2 == NorthAmerica) {
						HRange = numLevel3s[GlobalZone][NorthAmerica];
					} else if (HChoice2 == Europe) {
						for (j=0;j<VRange;j++) {
							for (i=0;i<numLevel3s[GlobalZone][Europe];i++) {
								displayData[j][i] = displayData[j][i+numLevel3s[GlobalZone][NorthAmerica]];
							}
						}
						HRange = numLevel3s[GlobalZone][Europe];
					} else if (HChoice2 == AsiaPacific) {
						for (j=0;j<VRange;j++) {
							for (i=0;i<numLevel3s[GlobalZone][AsiaPacific];i++) {
								displayData[j][i] = displayData[j][i+numLevel3s[GlobalZone][NorthAmerica]+numLevel3s[GlobalZone][Europe]];
							}
						}
						HRange = numLevel3s[GlobalZone][AsiaPacific];
					}
				}
			}
		} else {
			if (Hlevel == 1) {
				if (HChoice1 == Quarter) {
					for (j=0;j<VRange;j++) {
						for (i=1;i<numLevel3s[Quarter][0];i++) {
							displayData[j][0] += displayData[j][i];
						}
						displayData[j][1] = displayData[j][numLevel3s[Quarter][0]];
						displayData[j][2] = displayData[j][2*numLevel3s[Quarter][0]];
						displayData[j][3] = displayData[j][3*numLevel3s[Quarter][0]];
						for (i=1;i<numLevel3s[Quarter][0];i++) {
							displayData[j][1] += displayData[j][i+numLevel3s[Quarter][0]];
							displayData[j][2] += displayData[j][i+2*numLevel3s[Quarter][0]];
							displayData[j][3] += displayData[j][i+3*numLevel3s[Quarter][0]];
						}
					}
					HRange = 4;
				} else if (HChoice1 == Month) {
					for (j=0;j<VRange;j++) {
						for (i=1;i<numLevel3s[Month][0];i++) {
							displayData[j][0] += displayData[j][i];
						}
						l = numLevel3s[Month][0];
						for (k=1;k<numLevel2s[Month];k++) {
							displayData[j][k] = displayData[j][l];
							for (i=1;i<numLevel3s[Month][k];i++) {
								displayData[j][k] += displayData[j][l+i];
							}
							l += numLevel3s[Month][k];
						}
					}
					HRange = 12;
				}
			} else if (Hlevel == 2) {
				if (HChoice1 == Quarter) {
					if (HChoice2 == 0) {
					} else if (HChoice2 == 1) {
						for (j=0;j<VRange;j++) {
							for (i=0;i<13;i++) {
								displayData[j][i] = displayData[j][i+13];
							}
						}
					} else if (HChoice2 == 2) {
						for (j=0;j<VRange;j++) {
							for (i=0;i<13;i++) {
								displayData[j][i] = displayData[j][i+26];
							}
						}
					} else if (HChoice2 == 3) {
						for (j=0;j<VRange;j++) {
							for (i=0;i<13;i++) {
								displayData[j][i] = displayData[j][i+39];
							}
						}
					}
					HRange = 13;
				} else if (HChoice1 == Month) {
					k = 0;
					l = 0;
					while (k < HChoice2) {
						l += numLevel3s[Month][k];
						k++;
					};
					for (j=0;j<VRange;j++) {
						for (i=0;i<4;i++) {
							displayData[j][i] = displayData[j][i+l];
						}
						if (HChoice2 != 11)
							displayData[j][4] = displayData[j][4+l];
					}
					HRange = numLevel3s[Month][k];
				}
			}
		}
	}

	/* Compute a space-sensitive string to represent a number for display. */
	private String computeString(int inInt) {

		if (inInt > 1000000) {
			int digits = inInt/1000000;
			if (digits <10) {
				int frac = (inInt-digits*1000000)/10000;
				if (frac > 9) {
					return((new Integer(digits)).toString()+"."+(new Integer(frac)).toString()+"M");
				} else {
					return((new Integer(digits)).toString()+".0"+(new Integer(frac)).toString()+"M");
				}
			} else {
				int frac = (inInt-digits*1000000)/100000;
				return((new Integer(digits)).toString()+"."+(new Integer(frac)).toString()+"M");
			}
		} else if (inInt > 1000) {
			int digits = inInt/1000;
			return((new Integer(digits)).toString()+"K");
		} else if (inInt < 0) {
			return("");
		}
		return(new Integer(inInt).toString());
	}

	/* Do a final filter on the data to be displayed in case the user has chosen to see only the total */
	/* of a row or column, or a single value from that row or column, or -- the usual -- all values in */
	/* the row or column. */
	private void drawValues(Color histColour, Color textColour) {
	
		if (VtheTotal) {
			for (i=0;i<HRange;i++) {
				for (j=1;j<VRange;j++) {
					displayData[0][i] += displayData[j][i];
				}
			}
			VRange = 1;
		} else if (VoneOf) {
			for (i=0;i<HRange;i++) {
				displayData[0][i] = displayData[VtheOne][i];
			}
			VRange = 1;
		}
		if (HtheTotal) {
			for (i=0;i<VRange;i++) {
				for (j=1;j<HRange;j++) {
					displayData[i][0] += displayData[i][j];
				}
			}
			HRange = 1;
		} else if (HoneOf) {
			for (i=0;i<VRange;i++) {
				displayData[i][0] = displayData[i][HtheOne];
			}
			HRange = 1;
		}
		gg.setColor(Color.white);
		gg.fillRect(DataL+2,VTotalT,HTotalR-DataL,DataB-VTotalT);
		drawValues2(histColour, textColour);
	}

	/* Either draw a histogram or a matrix a values in the data display field. */
	private void drawValues2(Color histColour, Color textColour) {

		if ((VRange==1)&&(HRange>1)) {
			int tempMax = 0;
			for (i=0;i<HRange;i++) {
				if (displayData[0][i] > tempMax)
					tempMax = displayData[0][i];
			}
			if (tempMax > 0) {
				gg.setColor(histColour);
				for (j=0;j<HRange;j++) {
					gg.fillRect(DataL+(j*(DataR-DataL))/HRange+3,DataB-(((DataB-DataT)*displayData[0][j])/tempMax),(DataR-DataL)/HRange-3,(((DataB-DataT)*displayData[0][j])/tempMax)-1);
				}
			}
			gg.setColor(textColour);
			if ((DataR-DataL)/HRange > 30) {
				for (j=0;j<HRange;j++) {
					gg.drawString(computeString(displayData[0][j]),DataL+(((2*j+1)*(DataR-DataL))/2)/HRange-12,VTotalT+12);
				}
			} else {
				gg.drawLine(HTotalL,VTotalB,HTotalL+10,VTotalB);
				gg.drawString(computeString(tempMax),HTotalL+2,VTotalB+12);
				gg.drawString("0",HTotalL+2,DataB-3);
			}
		} else if ((VRange>1)&&(HRange==1)) {
			int tempMax = 0;
			for (i=0;i<VRange;i++) {
				if (displayData[i][0] > tempMax)
					tempMax = displayData[i][0];
			}
			if (tempMax > 0) {
				gg.setColor(histColour);
				for (j=0;j<VRange;j++) {
					gg.fillRect(DataL+2,DataT+(j*(DataB-DataT))/VRange+1,(((DataR-DataL)*displayData[j][0])/tempMax)-1,(DataB-DataT)/VRange-1);
				}
			}
			gg.setColor(textColour);
			if ((DataB-DataT)/VRange > 14) {
				for (j=0;j<VRange;j++) {
					gg.drawString(computeString(displayData[j][0]),DataR+3,DataT+(((2*j+1)*(DataB-DataT))/2)/VRange+3);
				}
			} else {
				gg.drawLine(HTotalL,VTotalB,HTotalL,VTotalB-10);
				gg.drawString(computeString(tempMax),HTotalL-30,VTotalB-3);
				gg.drawString("0",DataL+4,VTotalB-3);
			}

		} else {
			if ((((DataR-DataL)/HRange)>=30)&&(((DataB-DataT)/VRange)>=15)) {
				gg.setColor(textColour);
				for (i=0;i<VRange;i++) {
					for (j=0;j<HRange;j++) {
						gg.drawString(computeString(displayData[i][j]),DataL+(((2*j+1)*(DataR-DataL))/2)/HRange-13,DataT+(((2*i+1)*(DataB-DataT))/2)/VRange+3);
					}
				}
			} else {
				gg.setColor(histColour);
				int tempMax = 0;
				for (i=0;i<VRange;i++) {
					for (j=0;j<HRange;j++) {
						if (displayData[i][j] > tempMax)
							tempMax = displayData[i][j];
					}
				}
				if (tempMax > 0) {
					for (i=0;i<VRange;i++) {
						for (j=0;j<HRange;j++) {
							if (displayData[i][j] > 0) {
								if (HRange > VRange) {
									gg.fillRect(DataL+(j*(DataR-DataL))/HRange+1,DataT+(i*(DataB-DataT))/VRange+(((tempMax-displayData[i][j])*((DataB-DataT)/VRange))/tempMax)+1,(DataR-DataL)/HRange-1,(DataB-DataT)/VRange-(((tempMax-displayData[i][j])*((DataB-DataT)/VRange))/tempMax)-1);
								} else {
									gg.fillRect(DataL+(j*(DataR-DataL))/HRange+1,DataT+(i*(DataB-DataT))/VRange+1,(DataR-DataL)/HRange-(((tempMax-displayData[i][j])*((DataR-DataL)/HRange))/tempMax)-1,(DataB-DataT)/VRange-1);
								}
							}
						}
					}
				}
				gg.setColor(textColour);
				if ((((DataR-DataL)/HRange)>=10)&&(((DataB-DataT)/VRange)<15)) {
					for (i=0;i<HRange;i++) {
						gg.drawLine(DataL+((i+1)*(DataR-DataL))/HRange,VTotalB-10,DataL+((i+1)*(DataR-DataL))/HRange,VTotalB);
						gg.drawLine(DataL+((i)*(DataR-DataL))/HRange,VTotalB-10,DataL+((i)*(DataR-DataL))/HRange,VTotalB);
						if (((DataR-DataL)/HRange)>=35) {
							gg.drawString(computeString(tempMax),DataL+((i+1)*(DataR-DataL))/HRange-30,VTotalB-4);
							gg.drawString("0",DataL+((i)*(DataR-DataL))/HRange+3,VTotalB-4);
						}
					}
				} else 	if ((((DataR-DataL)/HRange)<30)&&(((DataB-DataT)/VRange)>=15)) {
					for (i=0;i<VRange;i++) {
						gg.drawLine(DataR,DataT+(i*(DataB-DataT))/VRange,DataR+10,DataT+(i*(DataB-DataT))/VRange);
						gg.drawLine(DataR,DataT+((i+1)*(DataB-DataT))/VRange,DataR+10,DataT+((i+1)*(DataB-DataT))/VRange);
						if (((DataB-DataT)/VRange)>=20) {
							gg.drawString(computeString(tempMax),DataR+3,DataT+(i*(DataB-DataT))/VRange+12);
							gg.drawString("0",DataR+3,DataT+((i+1)*(DataB-DataT))/VRange-3);
						}
					}
				}
			}
		}
	}

	/* This draws a control button.  I didn't mix Java API buttons with my use of the applet panel as */
	/* a drawing area. */
	private void drawButton(Color inC,int inL,int inR,int inT,int inB) {

		gg.setColor(inC);
		gg.fillRect(inL,inT,inR-inL,inB-inT);
		gg.setColor(Color.lightGray);
		gg.drawLine(inL,inT,inR,inT);
		gg.drawLine(inL-1,inT-1,inR+1,inT-1);
		gg.drawLine(inL,inT,inL,inB);
		gg.drawLine(inL-1,inT-1,inL-1,inB+1);
		gg.setColor(Color.darkGray);
		gg.drawLine(inR,inB,inL,inB);
		gg.drawLine(inR+1,inB+1,inL-1,inB+1);
		gg.drawLine(inR,inB,inR,inT);
		gg.drawLine(inR+1,inB+1,inR+1,inT-1);
	}

	/* This routine draws the whole scene: axes, labels, and data field. */
	private void drawState() {
	
		if (runningDemo) {
			drawButton(Color.red,DemoL,DemoR,DemoT,DemoB);
			gg.setColor(Color.black);
			gg.drawString("Stop",DemoL+10,DemoB-10);
		} else {
			drawButton(Color.green,DemoL,DemoR,DemoT,DemoB);
			gg.setColor(Color.black);
			gg.drawString("Demo",DemoL+10,DemoB-10);
		}
		if (smoothTransition) {
			drawButton(lightBlue,transTypeL,transTypeR,transTypeT,transTypeB);
			gg.setColor(Color.black);
			gg.drawString("Smooth",transTypeL+10,transTypeB-10);
		} else {
			drawButton(lightBlue,transTypeL,transTypeR,transTypeT,transTypeB);
			gg.setColor(Color.black);
			gg.drawString("Jump",transTypeL+13,transTypeB-10);
		}
		drawVRootBlock();
		drawVTotal();
		drawHTotal();
		if (Vlevel == 0) {
			drawVExp(0,1,1,3,Color.white);
			drawVViewingBlock(numLevel1s,level1Colours,level1Strings);
		} else if (Vlevel == 1) {
			drawVExp(0,1,1,1,Color.white);
			drawVExp(1,VChoice1,numLevel1s,3,level1Colours[VChoice1]);
			drawVBlock(1,numLevel1s,level1Colours);
			if (VChoice1 == Week) {
				drawVViewingWeeks(numLevel2s[VChoice1],level2Colours[VChoice1],level2Strings[VChoice1]);
			} else {
				drawVViewingBlock(numLevel2s[VChoice1],level2Colours[VChoice1],level2Strings[VChoice1]);
			}
		} else if (Vlevel == 2) {
			drawVExp(0,1,1,1,Color.white);
			drawVExp(1,VChoice1,numLevel1s,2,level1Colours[VChoice1]);
			drawVExp(2,VChoice2,numLevel2s[VChoice1],3,level2Colours[VChoice1][VChoice2]);
			drawVBlock(1,numLevel1s,level1Colours);
			drawVBlock(2,numLevel2s[VChoice1],level2Colours[VChoice1]);
			drawVViewingBlock(numLevel3s[VChoice1][VChoice2],level3Colours[VChoice1][VChoice2],level3Strings[VChoice1][VChoice2]);
		}
		drawHRootBlock();
		if (Hlevel == 0) {
			drawHExp(0,1,1,3,Color.white);
			drawHViewingBlock(numLevel1s,level1Colours,level1Strings);
		} else if (Hlevel == 1) {
			drawHExp(0,1,1,1,Color.white);
			drawHExp(1,HChoice1,numLevel1s,3,level1Colours[HChoice1]);
			drawHBlock(1,numLevel1s,level1Colours);
			if (HChoice1 == Week) {
				drawHViewingWeeks(numLevel2s[HChoice1],level2Colours[HChoice1],level2Strings[HChoice1]);
			} else {
				drawHViewingBlock(numLevel2s[HChoice1],level2Colours[HChoice1],level2Strings[HChoice1]);
			}
		} else if (Hlevel == 2) {
			drawHExp(0,1,1,1,Color.white);
			drawHExp(1,HChoice1,numLevel1s,2,level1Colours[HChoice1]);
			drawHExp(2,HChoice2,numLevel2s[HChoice1],3,level2Colours[HChoice1][HChoice2]);
			drawHBlock(1,numLevel1s,level1Colours);
			drawHBlock(2,numLevel2s[HChoice1],level2Colours[HChoice1]);
			drawHViewingBlock(numLevel3s[HChoice1][HChoice2],level3Colours[HChoice1][HChoice2],level3Strings[HChoice1][HChoice2]);
		}
		computeValues();
		drawValues(histFadeColours[0], textFadeColours[0]);
	}

	/* This routine initializes all of the data set meta-structure, and the colours to be used in */
	/* drawing the axes. */
	public void init() {

		setBackground(Color.white);
		setForeground(Color.black);

		numLevel2s[GlobalZone] = 3;
		numLevel2s[Category] = 4;
		numLevel2s[Line] = 3;
		numLevel2s[Quarter] = 4;
		numLevel2s[Month] = 12;
		numLevel2s[Week] = 52;
		numLevel3s[GlobalZone][NorthAmerica] = 6;
		numLevel3s[GlobalZone][Europe] = 5;
		numLevel3s[GlobalZone][AsiaPacific] = 4;
		numLevel3s[Category][Luxury] = 3;
		numLevel3s[Category][SportsCar] = 3;
		numLevel3s[Category][Economy] = 3;
		numLevel3s[Category][Utility] = 3;
		numLevel3s[Line][American] = 4;
		numLevel3s[Line][European] = 4;
		numLevel3s[Line][Japanese] = 4;
		numLevel3s[Quarter][0] = 13;
		numLevel3s[Quarter][1] = 13;
		numLevel3s[Quarter][2] = 13;
		numLevel3s[Quarter][3] = 13;
		numLevel3s[Month][0] = 4;
		numLevel3s[Month][1] = 4;
		numLevel3s[Month][2] = 5;
		numLevel3s[Month][3] = 4;
		numLevel3s[Month][4] = 5;
		numLevel3s[Month][5] = 4;
		numLevel3s[Month][6] = 4;
		numLevel3s[Month][7] = 5;
		numLevel3s[Month][8] = 4;
		numLevel3s[Month][9] = 4;
		numLevel3s[Month][10] = 5;
		numLevel3s[Month][11] = 4;
		numLevel3s[Week][0] = 5;
		numLevel3s[Week][1] = 5;
		numLevel3s[Week][2] = 5;
		numLevel3s[Week][3] = 5;
		numLevel3s[Week][4] = 5;
		numLevel3s[Week][5] = 5;
		numLevel3s[Week][6] = 5;
		numLevel3s[Week][7] = 5;
		numLevel3s[Week][8] = 5;
		numLevel3s[Week][9] = 5;
		numLevel3s[Week][10] = 2;
		for (i=0;i<7;i++) {
			level1Colours[i] = Color.black;
			level1Strings[i] = "NULL";
			for (j=0;j<13;j++) {
				level2Colours[i][j] = Color.black;
				level2Strings[i][j] = "NULL";
				for (k=0;k<14;k++) {
					level3Colours[i][j][k] = Color.black;
					level3Strings[i][j][k] = "NULL";
				};
			};
		};
		level1Colours[GlobalZone] = new Color(0,250,0);
		level1Colours[Category] = new Color(250,175,175);
		level1Colours[Line] = new Color(250,250,0);
		level1Colours[Quarter] = new Color(150,150,250);
		level1Colours[Month] = new Color(200,200,250);
		level1Colours[Week] = new Color(250,250,250);
		level2Colours[GlobalZone][NorthAmerica] = new Color(0,225,0);
		level2Colours[GlobalZone][Europe] = new Color(0,200,0);
		level2Colours[GlobalZone][AsiaPacific] = new Color(0,175,0);
		level2Colours[Category][Luxury] = new Color(238,175,175);
		level2Colours[Category][SportsCar] = new Color(226,175,175);
		level2Colours[Category][Economy] = new Color(214,175,175);
		level2Colours[Category][Utility] = new Color(202,175,175);
		level2Colours[Line][American] = new Color(225,225,0);
		level2Colours[Line][European] = new Color(200,200,0);
		level2Colours[Line][Japanese] = new Color(175,175,0);
		level2Colours[Quarter][0] = new Color(162,162,250);
		level2Colours[Quarter][1] = new Color(174,174,250);
		level2Colours[Quarter][2] = new Color(186,186,250);
		level2Colours[Quarter][3] = new Color(198,198,250);
		level2Colours[Month][0] = new Color(204,204,250);
		level2Colours[Month][1] = new Color(208,208,250);
		level2Colours[Month][2] = new Color(212,212,250);
		level2Colours[Month][3] = new Color(216,216,250);
		level2Colours[Month][4] = new Color(220,220,250);
		level2Colours[Month][5] = new Color(224,224,250);
		level2Colours[Month][6] = new Color(228,228,250);
		level2Colours[Month][7] = new Color(232,232,250);
		level2Colours[Month][8] = new Color(236,236,250);
		level2Colours[Month][9] = new Color(240,240,250);
		level2Colours[Month][10] = new Color(244,244,250);
		level2Colours[Month][11] = new Color(248,248,250);
		level3Colours[GlobalZone][NorthAmerica][Canada] = new Color(0,229,0);
		level3Colours[GlobalZone][NorthAmerica][USAtlantic] = new Color(0,234,0);
		level3Colours[GlobalZone][NorthAmerica][USPacific] = new Color(0,238,0);
		level3Colours[GlobalZone][NorthAmerica][USMidwest] = new Color(0,242,0);
		level3Colours[GlobalZone][NorthAmerica][USSouth] = new Color(0,246,0);
		level3Colours[GlobalZone][NorthAmerica][Mexico] = new Color(0,250,0);
		level3Colours[GlobalZone][Europe][UK] = new Color(0,205,0);
		level3Colours[GlobalZone][Europe][France] = new Color(0,210,0);
		level3Colours[GlobalZone][Europe][Germany] = new Color(0,215,0);
		level3Colours[GlobalZone][Europe][Italy] = new Color(0,220,0);
		level3Colours[GlobalZone][Europe][Scandanavia] = new Color(0,225,0);
		level3Colours[GlobalZone][AsiaPacific][Japan] = new Color(0,181,0);
		level3Colours[GlobalZone][AsiaPacific][China] = new Color(0,187,0);
		level3Colours[GlobalZone][AsiaPacific][HongKong] = new Color(0,193,0);
		level3Colours[GlobalZone][AsiaPacific][Australia] = new Color(0,199,0);
		level3Colours[Category][Luxury][CatAmeriLux] = new Color(241,175,175);
		level3Colours[Category][Luxury][CatEuroLux] = new Color(244,175,175);
		level3Colours[Category][Luxury][CatNipponLux] = new Color(247,175,175);
		level3Colours[Category][SportsCar][CatAmeriSport] = new Color(229,175,175);
		level3Colours[Category][SportsCar][CatEuroSport] = new Color(232,175,175);
		level3Colours[Category][SportsCar][CatNipponSport] = new Color(235,175,175);
		level3Colours[Category][Economy][CatAmerEcon] = new Color(217,175,175);
		level3Colours[Category][Economy][CatEurEcon] = new Color(220,175,175);
		level3Colours[Category][Economy][CatNipponEcon] = new Color(223,175,175);
		level3Colours[Category][Utility][CatAmerUtil] = new Color(205,175,175);
		level3Colours[Category][Utility][CatEurUtil] = new Color(208,175,175);
		level3Colours[Category][Utility][CatNipponUtil] = new Color(211,175,175);
		level3Colours[Line][American][LineAmeriLux] = new Color(231,231,0);
		level3Colours[Line][American][LineAmeriSport] = new Color(237,237,0);
		level3Colours[Line][American][LineAmerEcon] = new Color(243,243,0);
		level3Colours[Line][American][LineAmerUtil] = new Color(249,249,0);
		level3Colours[Line][European][LineEuroLux] = new Color(206,206,0);
		level3Colours[Line][European][LineEuroSport] = new Color(212,212,0);
		level3Colours[Line][European][LineEurEcon] = new Color(218,218,0);
		level3Colours[Line][European][LineEurUtil] = new Color(224,224,0);
		level3Colours[Line][Japanese][LineNipponLux] = new Color(181,181,0);
		level3Colours[Line][Japanese][LineNipponSport] = new Color(187,187,0);
		level3Colours[Line][Japanese][LineNipponEcon] = new Color(193,193,0);
		level3Colours[Line][Japanese][LineNipponUtil] = new Color(199,199,0);
		for (i=0;i<4;i++) {
			for (j=0;j<13;j++)
				level3Colours[Quarter][i][j] = new Color(250,250,250);
		};
		for (i=0;i<12;i++) {
			for (j=0;j<5;j++)
				level3Colours[Month][i][j] = new Color(250,250,250);
		};
		for (i=0;i<11;i++)
			for (j=0;j<5;j++)
				level3Colours[Week][i][j] = new Color(250,250,250);

		level1Strings[GlobalZone] = "Zone";
		level1Strings[Category] = "Categ.";
		level1Strings[Line] = "Line";
		level1Strings[Quarter] = "Quart'r";
		level1Strings[Month] = "Month";
		level1Strings[Week] = "Week";
		level2Strings[GlobalZone][NorthAmerica] = "N.A.";
		level2Strings[GlobalZone][Europe] = "Eur.";
		level2Strings[GlobalZone][AsiaPacific] = "AsiaP";
		level2Strings[Category][Luxury] = "Lux";
		level2Strings[Category][SportsCar] = "Sport";
		level2Strings[Category][Economy] = "Econ";
		level2Strings[Category][Utility] = "Util";
		level2Strings[Line][American] = "ALine";
		level2Strings[Line][European] = "ELine";
		level2Strings[Line][Japanese] = "JLine";
		for (i=0;i<4;i++)
			level2Strings[Quarter][i] = "Q"+(i+1);
		level2Strings[Month][0] = "Jan";
		level2Strings[Month][1] = "Feb";
		level2Strings[Month][2] = "Mar";
		level2Strings[Month][3] = "Apr";
		level2Strings[Month][4] = "May";
		level2Strings[Month][5] = "Jun";
		level2Strings[Month][6] = "Jul";
		level2Strings[Month][7] = "Aug";
		level2Strings[Month][8] = "Sep";
		level2Strings[Month][9] = "Oct";
		level2Strings[Month][10] = "Nov";
		level2Strings[Month][11] = "Dec";
		level3Strings[GlobalZone][NorthAmerica][Canada] = "Can.";
		level3Strings[GlobalZone][NorthAmerica][USAtlantic] = "USAtl";
		level3Strings[GlobalZone][NorthAmerica][USPacific] = "USPac";
		level3Strings[GlobalZone][NorthAmerica][USMidwest] = "USMid";
		level3Strings[GlobalZone][NorthAmerica][USSouth] = "USSou";
		level3Strings[GlobalZone][NorthAmerica][Mexico] = "Mex";
		level3Strings[GlobalZone][Europe][UK] = "UK";
		level3Strings[GlobalZone][Europe][France] = "Fr.";
		level3Strings[GlobalZone][Europe][Germany] = "Deu.";
		level3Strings[GlobalZone][Europe][Italy] = "It.";
		level3Strings[GlobalZone][Europe][Scandanavia] = "Scand.";
		level3Strings[GlobalZone][AsiaPacific][Japan] = "Japan";
		level3Strings[GlobalZone][AsiaPacific][China] = "China";
		level3Strings[GlobalZone][AsiaPacific][HongKong] = "HK";
		level3Strings[GlobalZone][AsiaPacific][Australia] = "Aus.";
		level3Strings[Category][Luxury][CatAmeriLux] = "ALux";
		level3Strings[Category][Luxury][CatEuroLux] = "ELux";
		level3Strings[Category][Luxury][CatNipponLux] = "JLux";
		level3Strings[Category][SportsCar][CatAmeriSport] = "ASpor";
		level3Strings[Category][SportsCar][CatEuroSport] = "ESpor";
		level3Strings[Category][SportsCar][CatNipponSport] = "JSpor";
		level3Strings[Category][Economy][CatAmerEcon] = "AEcon";
		level3Strings[Category][Economy][CatEurEcon] = "EEcon";
		level3Strings[Category][Economy][CatNipponEcon] = "JEcon";
		level3Strings[Category][Utility][CatAmerUtil] = "AUtil";
		level3Strings[Category][Utility][CatEurUtil] = "EUtil";
		level3Strings[Category][Utility][CatNipponUtil] = "JUtil";
		level3Strings[Line][American][LineAmeriLux] = "ALux";
		level3Strings[Line][American][LineAmeriSport] = "ASpor";
		level3Strings[Line][American][LineAmerEcon] = "AEcon";
		level3Strings[Line][American][LineAmerUtil] = "AUtil";
		level3Strings[Line][European][LineEuroLux] = "ELux";
		level3Strings[Line][European][LineEuroSport] = "ESpor";
		level3Strings[Line][European][LineEurEcon] = "EEcon";
		level3Strings[Line][European][LineEurUtil] = "EUtil";
		level3Strings[Line][Japanese][LineNipponLux] = "JLux";
		level3Strings[Line][Japanese][LineNipponSport] = "JSpor";
		level3Strings[Line][Japanese][LineNipponEcon] = "JEcon";
		level3Strings[Line][Japanese][LineNipponUtil] = "JUtil";
		for (i=0;i<4;i++) {
			for (j=0;j<numLevel3s[Quarter][i];j++)
				level3Strings[Quarter][i][j] = "W"+((i*13)+j+1);
		};
		k = 1;
		for (i=0;i<12;i++) {
			for (j=0;j<numLevel3s[Month][i];j++) {
				level3Strings[Month][i][j] = "W"+k;
				k++;
			};
		};

		Veach = false;
		VoneOf = false;
		VtheTotal = true;
		Heach = false;
		HoneOf = false;
		HtheTotal = true;

		histFadeColours = new Color[transSteps];
		textFadeColours = new Color[transSteps];
		for (i=0;i<transSteps;i++) {
			histFadeColours[i] = new Color(200+(i*55)/transSteps,200+(i*55)/transSteps,200+(i*55)/transSteps);
			textFadeColours[i] = new Color((i*255)/transSteps,(i*255)/transSteps,(i*255)/transSteps);
		}

		gg = this.getGraphics();
		repaint();
	}

	/* A simple paint routine. */
	public void paint(Graphics g) {

		g.setPaintMode();
		g.setFont(new Font("Times",Font.PLAIN,10));
		drawState();
	}

	/* When clearing is required to tidy up the data display field. */
	public void clearDataArea() {

		gg.setPaintMode();
		gg.setColor(Color.white);
		gg.fillRect(0,0,1000,1000);
	}

	/* My sleep function. */
	private void doDelay(int inD) {

		try {
			Thread.sleep(inD);
		} catch (InterruptedException e) {
			System.out.println("Interrupted...");
		};
	}

	/* This is the sparkle before a smooth transition to give feedback on the user's choice. */
	private void drawBurst(int inX, int inY) {

		gg.setColor(Color.black);
		gg.drawLine(inX-1,inY,inX-1,inY-5);
		gg.drawLine(inX-5,inY-1,inX,inY-1);
		gg.drawLine(inX+1,inY,inX+1,inY+5);
		gg.drawLine(inX+5,inY+1,inX,inY+1);
		gg.setColor(Color.white);
		gg.drawLine(inX+1,inY,inX+1,inY-5);
		gg.drawLine(inX-5,inY+1,inX,inY+1);
		gg.drawLine(inX-1,inY,inX-1,inY+5);
		gg.drawLine(inX+5,inY-1,inX,inY-1);
		doDelay(burstDelay);
		gg.setColor(Color.white);
		gg.drawLine(inX-1,inY,inX-1,inY-5);
		gg.drawLine(inX-5,inY-1,inX,inY-1);
		gg.drawLine(inX+1,inY,inX+1,inY+5);
		gg.drawLine(inX+5,inY+1,inX,inY+1);
		gg.setColor(Color.black);
		gg.drawLine(inX+1,inY,inX+1,inY-5);
		gg.drawLine(inX-5,inY+1,inX,inY+1);
		gg.drawLine(inX-1,inY,inX-1,inY+5);
		gg.drawLine(inX+5,inY-1,inX,inY-1);
		doDelay(burstDelay);
		gg.setColor(Color.black);
		gg.drawLine(inX-1,inY,inX-1,inY-5);
		gg.drawLine(inX-5,inY-1,inX,inY-1);
		gg.drawLine(inX+1,inY,inX+1,inY+5);
		gg.drawLine(inX+5,inY+1,inX,inY+1);
		gg.setColor(Color.white);
		gg.drawLine(inX+1,inY,inX+1,inY-5);
		gg.drawLine(inX-5,inY+1,inX,inY+1);
		gg.drawLine(inX-1,inY,inX-1,inY+5);
		gg.drawLine(inX+5,inY-1,inX,inY-1);
		doDelay(burstDelay);
		gg.setColor(Color.white);
		gg.drawLine(inX-1,inY,inX-1,inY-5);
		gg.drawLine(inX-5,inY-1,inX,inY-1);
		gg.drawLine(inX+1,inY,inX+1,inY+5);
		gg.drawLine(inX+5,inY+1,inX,inY+1);
		gg.setColor(Color.black);
		gg.drawLine(inX+1,inY,inX+1,inY-5);
		gg.drawLine(inX-5,inY+1,inX,inY+1);
		gg.drawLine(inX-1,inY,inX-1,inY+5);
		gg.drawLine(inX+5,inY-1,inX,inY-1);
		doDelay(burstDelay);
		gg.setColor(Color.black);
		gg.drawLine(inX-1,inY,inX-1,inY-5);
		gg.drawLine(inX-5,inY-1,inX,inY-1);
		gg.drawLine(inX+1,inY,inX+1,inY+5);
		gg.drawLine(inX+5,inY+1,inX,inY+1);
		gg.setColor(Color.white);
		gg.drawLine(inX+1,inY,inX+1,inY-5);
		gg.drawLine(inX-5,inY+1,inX,inY+1);
		gg.drawLine(inX-1,inY,inX-1,inY+5);
		gg.drawLine(inX+5,inY-1,inX,inY-1);
		doDelay(burstDelay);
	}

	/* This is a routine for drawing a coloured vertical axis block during a transition. */
	public void VDrawBox(int theLevel, int leftEdge, int rightEdge) {

		int localNC;
		Color localC[];
		if (theLevel == 0) {
			localNC = numLevel1s;
			localC = level1Colours;
		} else if (theLevel == 1) {
			localNC = numLevel2s[VChoice1];
			localC = level2Colours[VChoice1];
		} else {
			localNC = numLevel3s[VChoice1][VChoice2];
			localC = level3Colours[VChoice1][VChoice2];
		}
		if ((theLevel == 1) && (VChoice1 == Week)) {
			gg.setColor(Color.white);
			gg.fillRect(leftEdge,VBlocksT,rightEdge-leftEdge,VBlocksB-VBlocksT);
		} else {
			for (j=0;j<localNC;j++) {
				gg.setColor(localC[j]);
				if (j == (localNC-1)) {
					gg.fillRect(leftEdge,VBlocksT+j*(VBlocksB-VBlocksT)/localNC,rightEdge-leftEdge,VBlocksB-(VBlocksT+j*(VBlocksB-VBlocksT)/localNC));
				} else {
					gg.fillRect(leftEdge,VBlocksT+j*(VBlocksB-VBlocksT)/localNC,rightEdge-leftEdge,(VBlocksB-VBlocksT)/localNC);
				}
			}
		}
		gg.setColor(Color.black);
		gg.drawRect(leftEdge,VBlocksT,rightEdge-leftEdge,VBlocksB-VBlocksT);
		if ((theLevel != 1) || (VChoice1 != Week)) {
			for (j=0;j<localNC;j++) {
				if (j == (localNC-1)) {
					gg.drawRect(leftEdge,VBlocksT+j*(VBlocksB-VBlocksT)/localNC,rightEdge-leftEdge,VBlocksB-(VBlocksT+j*(VBlocksB-VBlocksT)/localNC));
				} else {
					gg.drawRect(leftEdge,VBlocksT+j*(VBlocksB-VBlocksT)/localNC,rightEdge-leftEdge,(VBlocksB-VBlocksT)/localNC);
				}
			}
		}
	}

	/* This is a routine for drawing a vertical axis trapezoid during a transition. */
	public void VDrawTrap(int inLevel, int leftEdge, int rightEdge) {

		int localNC = 0;
		int localChoice = 0;
		Polygon tempPoly = new Polygon();
		Polygon tempPoly2 = new Polygon();
		Polygon tempPoly3 = new Polygon();
		Color localC = null;
		if (inLevel == -1) {
			localC = Color.white;
			localNC = 5;
			localChoice = 2;
		} else if (inLevel == 0) {
			localC = level1Colours[VChoice1];
			localNC = numLevel1s;
			localChoice = VChoice1;
		} else if (inLevel == 1) {
			localC = level2Colours[VChoice1][VChoice2];
			localNC = numLevel2s[VChoice1];
			localChoice = VChoice2;
		}
		int correction = 1;
		if (inLevel == -1)
			correction = 0;
		tempPoly2.addPoint(leftEdge+correction,VBlocksT+localChoice*(VBlocksB-VBlocksT)/localNC);
		tempPoly2.addPoint(leftEdge+correction,VBlocksT);
		tempPoly2.addPoint(rightEdge-1,VBlocksT);
		tempPoly2.addPoint(leftEdge+correction,VBlocksT+localChoice*(VBlocksB-VBlocksT)/localNC);
		tempPoly3.addPoint(leftEdge+correction,VBlocksT+(localChoice+1)*(VBlocksB-VBlocksT)/localNC);
		tempPoly3.addPoint(leftEdge+correction,VBlocksB);
		tempPoly3.addPoint(leftEdge+correction,VBlocksB+2);
		tempPoly3.addPoint(rightEdge-1,VBlocksB+2);
		tempPoly3.addPoint(rightEdge-1,VBlocksB);
		tempPoly3.addPoint(leftEdge+correction,VBlocksT+(localChoice+1)*(VBlocksB-VBlocksT)/localNC);
		gg.setColor(Color.white);
		gg.fillPolygon(tempPoly2);
		gg.fillPolygon(tempPoly3);
		tempPoly.addPoint(leftEdge,VBlocksT+localChoice*(VBlocksB-VBlocksT)/localNC);
		tempPoly.addPoint(leftEdge,VBlocksT+(localChoice+1)*(VBlocksB-VBlocksT)/localNC);
		tempPoly.addPoint(rightEdge,VBlocksB);
		tempPoly.addPoint(rightEdge,VBlocksT);
		tempPoly.addPoint(leftEdge,VBlocksT+localChoice*(VBlocksB-VBlocksT)/localNC);
		gg.setColor(localC);
		gg.fillPolygon(tempPoly);
		gg.setColor(Color.black);
		gg.drawPolygon(tempPoly);
	}

	/* Display the vertical axis transition from level 0 to level 1. */
	public void VTrans01(int inX, int inY) {

		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		for (int i=0;i<=transSteps;i++) {
			VDrawTrap(-1,VRootL+VRootWidth,VBlock1L+((VBlock3L-VBlock1L)*(transSteps-i))/transSteps);
			if ((VBlock1R+((VBlock3R-VBlock1R)*(transSteps-i))/transSteps) >= VBlock3L) {
				VDrawBox(1,VBlock1R+((VBlock3R-VBlock1R)*(transSteps-i))/transSteps,VBlock3R);
			} else {
				VDrawTrap(0,VBlock1R+((VBlock3R-VBlock1R)*(transSteps-i))/transSteps,VBlock3L);
			}
			VDrawBox(0,VBlock1L+((VBlock3L-VBlock1L)*(transSteps-i))/transSteps,VBlock1R+((VBlock3R-VBlock1R)*(transSteps-i))/transSteps);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from level 1 to level 0. */
	public void VTrans10(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		gg.setColor(Color.black);
		gg.fillRect(VRootL,VRootT,VRootWidth,VRootHeight);
		for (int i=0;i<=transSteps;i++) {
			VDrawTrap(-1,VRootL+VRootWidth,VBlock1L+((VBlock3L-VBlock1L)*i)/transSteps);
			if ((VBlock1R+((VBlock3R-VBlock1R)*i)/transSteps) < VBlock3L) {
				VDrawTrap(0,VBlock1R+((VBlock3R-VBlock1R)*i)/transSteps,VBlock3L);
			}
			VDrawBox(0,VBlock1L+((VBlock3L-VBlock1L)*i)/transSteps,VBlock1R+((VBlock3R-VBlock1R)*i)/transSteps);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from level 2 to level 0. */
	public void VTrans20(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		gg.setColor(Color.black);
		gg.fillRect(VRootL,VRootT,VRootWidth,VRootHeight);
		for (int i=0;i<=transSteps;i++) {
			VDrawTrap(-1,VRootL+VRootWidth,VBlock1L+((VBlock3L-VBlock1L)*i)/transSteps);
			if ((VBlock2R+((VBlock3R-VBlock2R)*i)/transSteps) < VBlock3L)
				VDrawTrap(1,VBlock2R+((VBlock3R-VBlock2R)*i)/transSteps,VBlock3L);
			if ((VBlock1R+((VBlock3R-VBlock1R)*i)/transSteps) < (VBlock2L+((VBlock3R-VBlock2L)*i)/transSteps)) {
				VDrawTrap(0,VBlock1R+((VBlock3R-VBlock1R)*i)/transSteps,VBlock2L+((VBlock3R-VBlock2L)*i)/transSteps);
			}
			VDrawBox(0,VBlock1L+((VBlock3L-VBlock1L)*i)/transSteps,VBlock1R+((VBlock3R-VBlock1R)*i)/transSteps);
			VDrawBox(1,VBlock2L+((VBlock3R-VBlock2L)*i)/transSteps,VBlock2R+((VBlock3R-VBlock2R)*i)/transSteps);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from level 1 to level 2. */
	public void VTrans12(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		for (int i=0;i<=transSteps;i++) {
			VDrawTrap(0,VBlock1R,VBlock2L+((VBlock3L-VBlock2L)*(transSteps-i))/transSteps);
			if ((VBlock2R+((VBlock3R-VBlock2R)*(transSteps-i))/transSteps) >= VBlock3L) {
				VDrawBox(2,VBlock2R+((VBlock3R-VBlock2R)*(transSteps-i))/transSteps,VBlock3R);
			} else {
				VDrawTrap(1,VBlock2R+((VBlock3R-VBlock2R)*(transSteps-i))/transSteps,VBlock3L);
			}
			VDrawBox(1,VBlock2L+((VBlock3L-VBlock2L)*(transSteps-i))/transSteps,VBlock2R+((VBlock3R-VBlock2R)*(transSteps-i))/transSteps);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from either level 2 (or level 1) to (another choice in) */
	/* level 1. */
	public void VTrans211(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		for (int i=0;i<=transSteps;i++) {
			VDrawTrap(0,VBlock1R,VBlock1R+((VBlock3L-VBlock1R)*i)/transSteps);
			VDrawBox(1,VBlock1R+((VBlock3L-VBlock1R)*i)/transSteps,VBlock1R+((VBlock3R-VBlock1R)*i)/transSteps);
			VDrawBox(0,VBlock1L,VBlock1R);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from level 2 to another choice in level 2. */
	public void VTrans22(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		for (int i=0;i<=transSteps;i++) {
			VDrawTrap(1,VBlock2R,VBlock2R+((VBlock3L-VBlock2R)*i)/transSteps);
			VDrawBox(2,VBlock2R+((VBlock3L-VBlock2R)*i)/transSteps,VBlock2R+((VBlock3R-VBlock2R)*i)/transSteps);
			VDrawBox(1,VBlock2L,VBlock2R);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* This is a routine for drawing a coloured horizontal axis block during a transition. */
	public void HDrawBox(int theLevel, int bottomEdge, int topEdge) {

		int localNC;
		Color localC[];
		if (theLevel == 0) {
			localNC = numLevel1s;
			localC = level1Colours;
		} else if (theLevel == 1) {
			localNC = numLevel2s[HChoice1];
			localC = level2Colours[HChoice1];
		} else {
			localNC = numLevel3s[HChoice1][HChoice2];
			localC = level3Colours[HChoice1][HChoice2];
		}
		if ((theLevel == 1) && (HChoice1 == Week)) {
			gg.setColor(Color.white);
			gg.fillRect(HBlocksL,topEdge,HBlocksR-HBlocksL,bottomEdge-topEdge);
		} else {
			for (j=0;j<localNC;j++) {
				gg.setColor(localC[j]);
				if (j == (localNC-1)) {
					gg.fillRect(HBlocksL+j*(HBlocksR-HBlocksL)/localNC,topEdge,HBlocksR-(HBlocksL+j*(HBlocksR-HBlocksL)/localNC),bottomEdge-topEdge);
				} else {
					gg.fillRect(HBlocksL+j*(HBlocksR-HBlocksL)/localNC,topEdge,(HBlocksR-HBlocksL)/localNC,bottomEdge-topEdge);
				}
			}
		}
		gg.setColor(Color.black);
		gg.drawRect(HBlocksL,topEdge,HBlocksR-HBlocksL,bottomEdge-topEdge);
		if ((theLevel != 1) || (HChoice1 != Week)) {
			for (j=0;j<localNC;j++) {
				if (j == (localNC-1)) {
					gg.drawRect(HBlocksL+j*(HBlocksR-HBlocksL)/localNC,topEdge,HBlocksR-(HBlocksL+j*(HBlocksR-HBlocksL)/localNC),bottomEdge-topEdge);
				} else {
					gg.drawRect(HBlocksL+j*(HBlocksR-HBlocksL)/localNC,topEdge,(HBlocksR-HBlocksL)/localNC,bottomEdge-topEdge);
				}
			}
		}
	}

	/* This is a routine for drawing a horizontal axis trapezoid during a transition. */
	public void HDrawTrap(int inLevel, int bottomEdge, int topEdge) {

		int localNC = 0;
		int localChoice = 0;
		Polygon tempPoly = new Polygon();
		Polygon tempPoly2 = new Polygon();
		Polygon tempPoly3 = new Polygon();
		Color localC = null;
		if (inLevel == -1) {
			localC = Color.white;
			localNC = 5;
			localChoice = 2;
		} else if (inLevel == 0) {
			localC = level1Colours[HChoice1];
			localNC = numLevel1s;
			localChoice = HChoice1;
		} else if (inLevel == 1) {
			localC = level2Colours[HChoice1][HChoice2];
			localNC = numLevel2s[HChoice1];
			localChoice = HChoice2;
		}
		tempPoly2.addPoint(HBlocksL+localChoice*(HBlocksR-HBlocksL)/localNC,bottomEdge);
		tempPoly2.addPoint(HBlocksL,bottomEdge);
		tempPoly2.addPoint(HBlocksL,topEdge);
		tempPoly2.addPoint(HBlocksL+localChoice*(HBlocksR-HBlocksL)/localNC,bottomEdge);
		tempPoly3.addPoint(HBlocksL+(localChoice+1)*(HBlocksR-HBlocksL)/localNC,bottomEdge);
		tempPoly3.addPoint(HBlocksR,bottomEdge);
		tempPoly3.addPoint(HBlocksR+1,bottomEdge);
		tempPoly3.addPoint(HBlocksR+1,topEdge);
		tempPoly3.addPoint(HBlocksR,topEdge);
		tempPoly3.addPoint(HBlocksL+(localChoice+1)*(HBlocksR-HBlocksL)/localNC,bottomEdge);
		gg.setColor(Color.white);
		gg.fillPolygon(tempPoly2);
		gg.fillPolygon(tempPoly3);
		tempPoly.addPoint(HBlocksL+localChoice*(HBlocksR-HBlocksL)/localNC,bottomEdge);
		tempPoly.addPoint(HBlocksL+(localChoice+1)*(HBlocksR-HBlocksL)/localNC,bottomEdge);
		tempPoly.addPoint(HBlocksR,topEdge);
		tempPoly.addPoint(HBlocksL,topEdge);
		tempPoly.addPoint(HBlocksL+localChoice*(HBlocksR-HBlocksL)/localNC,bottomEdge);
		gg.setColor(localC);
		gg.fillPolygon(tempPoly);
		gg.setColor(Color.black);
		gg.drawPolygon(tempPoly);
	}

	/* Display the horizontal axis transition from level 0 to level 1. */
	public void HTrans01(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		for (int i=0;i<=transSteps;i++) {
			HDrawTrap(-1,HRootT,HBlock1B+((HBlock3B-HBlock1B)*(transSteps-i))/transSteps);
			HDrawBox(0,HBlock1B+((HBlock3B-HBlock1B)*(transSteps-i))/transSteps,HBlock1T+((HBlock3T-HBlock1T)*(transSteps-i))/transSteps);
			if ((HBlock1T+((HBlock3T-HBlock1T)*(transSteps-i))/transSteps) <= HBlock3B) {
				HDrawBox(1,HBlock1T+((HBlock3T-HBlock1T)*(transSteps-i))/transSteps,HBlock3T);
			} else {
				HDrawTrap(0,HBlock1T+((HBlock3T-HBlock1T)*(transSteps-i))/transSteps,HBlock3B);
			}
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from level 1 to level 0. */
	public void HTrans10(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		gg.setColor(Color.black);
		gg.fillRect(HRootL,HRootT,HRootWidth,HRootHeight);
		for (int i=0;i<=transSteps;i++) {
			HDrawTrap(-1,HRootT,HBlock1B+((HBlock3B-HBlock1B)*i)/transSteps);
			if ((HBlock1T+((HBlock3T-HBlock1T)*i)/transSteps) > HBlock3B) {
				HDrawTrap(0,HBlock1T+((HBlock3T-HBlock1T)*i)/transSteps,HBlock3B);
			}
			HDrawBox(0,HBlock1B+((HBlock3B-HBlock1B)*i)/transSteps,HBlock1T+((HBlock3T-HBlock1T)*i)/transSteps);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from level 2 to level 0. */
	public void HTrans20(int inX, int inY) {
		
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		gg.setColor(Color.black);
		gg.fillRect(HRootL,HRootT,HRootWidth,HRootHeight);
		for (int i=0;i<=transSteps;i++) {
			HDrawTrap(-1,HRootT,HBlock1B+((HBlock3B-HBlock1B)*i)/transSteps);
			if ((HBlock2T+((HBlock3T-HBlock2T)*i)/transSteps) > HBlock3B)
				HDrawTrap(1,HBlock2T+((HBlock3T-HBlock2T)*i)/transSteps,HBlock3B);
			if ((HBlock1T+((HBlock3T-HBlock1T)*i)/transSteps) > (HBlock2B+((HBlock3T-HBlock2B)*i)/transSteps)) {
				HDrawTrap(0,HBlock1T+((HBlock3T-HBlock1T)*i)/transSteps,HBlock2B+((HBlock3T-HBlock2B)*i)/transSteps);
			}
			HDrawBox(0,HBlock1B+((HBlock3B-HBlock1B)*i)/transSteps,HBlock1T+((HBlock3T-HBlock1T)*i)/transSteps);
			HDrawBox(1,HBlock2B+((HBlock3T-HBlock2B)*i)/transSteps,HBlock2T+((HBlock3T-HBlock2T)*i)/transSteps);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from level 1 to level 2. */
	public void HTrans12(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		for (int i=0;i<=transSteps;i++) {
			HDrawTrap(0,HBlock1T,HBlock2B+((HBlock3B-HBlock2B)*(transSteps-i))/transSteps);
			if ((HBlock2T+((HBlock3T-HBlock2T)*(transSteps-i))/transSteps) <= HBlock3B) {
				HDrawBox(2,HBlock2T+((HBlock3T-HBlock2T)*(transSteps-i))/transSteps,HBlock3T);
			} else {
				HDrawTrap(1,HBlock2T+((HBlock3T-HBlock2T)*(transSteps-i))/transSteps,HBlock3B);
			}
			HDrawBox(1,HBlock2B+((HBlock3B-HBlock2B)*(transSteps-i))/transSteps,HBlock2T+((HBlock3T-HBlock2T)*(transSteps-i))/transSteps);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from either level 2 (or level 1) to (another choice in) */
	/* level 1. */
	public void HTrans211(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		for (int i=0;i<=transSteps;i++) {
			HDrawTrap(0,HBlock1T,HBlock1T+((HBlock3B-HBlock1T)*i)/transSteps);
			HDrawBox(0,HBlock1B,HBlock1T);
			HDrawBox(1,HBlock1T+((HBlock3B-HBlock1T)*i)/transSteps,HBlock1T+((HBlock3T-HBlock1T)*i)/transSteps);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Display the vertical axis transition from level 2 to another choice in level 2. */
	public void HTrans22(int inX, int inY) {
	
		if (!smoothTransition) {
			clearDataArea();
			return;
		}
		drawBurst(inX,inY);
		for (int i=0;i<=transSteps;i++) {
			HDrawTrap(1,HBlock2T,HBlock2T+((HBlock3B-HBlock2T)*i)/transSteps);
			HDrawBox(2,HBlock2T+((HBlock3B-HBlock2T)*i)/transSteps,HBlock2T+((HBlock3T-HBlock2T)*i)/transSteps);
			HDrawBox(1,HBlock2B,HBlock2T);
			if (i<transSteps)
				drawValues2(histFadeColours[i], textFadeColours[i]);
			doDelay(transDelay);
		}
	}

	/* Handle events: basically watch for choices of transition type ('Smooth' or 'Jump'), demo control */
	/* ('Run' or 'Stop'), and clicks on the axes.  Clicks on the axes can mean changes in the levels    */
	/* displayed in the data set, changes in the choices made at each level in the data set, or changes */
	/* in the display filters for the chosen data (to show a 'Total' or just one of the elements in a   */
	/* list. */
	public boolean handleEvent(Event e) {

		int newChoice;
		boolean justStoppedDemo = false;

		if (e.id == Event.MOUSE_DOWN) {
			if (processingEvent) {
				if ((e.x>DemoL)&&(e.x<(DemoR))&&(e.y>DemoT)&&(e.y<(DemoB))) {
					if ((myThread != null) && (runningDemo)) {
						myThread.tryingToStop = true;
					}
				}
				return(true);
			}
			processingEvent = true;
			if (runningDemo) {
				if ((e.x>DemoL)&&(e.x<(DemoR))&&(e.y>DemoT)&&(e.y<(DemoB))) {
					runningDemo = false;
					justStoppedDemo = true;
					drawButton(Color.green,DemoL,DemoR,DemoT,DemoB);
					gg.setColor(Color.black);
					gg.drawString("Demo",DemoL+10,DemoB-10);
					processingEvent = false;
					myThread.stop();
				} else {
					e.x -= 1000;
					e.y -= 1000;
				}
			}
			if (((e.x>DemoL)&&(e.x<(DemoR))&&(e.y>DemoT)&&(e.y<(DemoB))) && (!justStoppedDemo)) {
				drawButton(Color.red,DemoL,DemoR,DemoT,DemoB);
				gg.setColor(Color.black);
				gg.drawString("Stop",DemoL+10,DemoB-10);
				runningDemo = true;
				myThread = new demoThread();
				myThread.setParent(this);
				myThread.start();
			} else if ((e.x>transTypeL)&&(e.x<(transTypeR))&&(e.y>transTypeT)&&(e.y<(transTypeB))) {
				if (smoothTransition) {
					smoothTransition = false;
					drawButton(lightBlue,transTypeL,transTypeR,transTypeT,transTypeB);
					gg.setColor(Color.black);
					gg.drawString("Jump",transTypeL+13,transTypeB-10);
				} else {
					smoothTransition = true;
					drawButton(lightBlue,transTypeL,transTypeR,transTypeT,transTypeB);
					gg.setColor(Color.black);
					gg.drawString("Smooth",transTypeL+10,transTypeB-10);
				}
			} else if ((e.x>VRootL)&&(e.x<(VRootL+VRootWidth))&&(e.y>VRootT)&&(e.y<(VRootT+VRootHeight))) {
				if (Vlevel == 1) {
					Vlevel = 0;
					Veach = false;
					VoneOf = false;
					VtheTotal = true;
					VTrans10((VRootR+VRootL)/2+2,(VRootB+VRootT)/2);
					drawState();
				} else if (Vlevel == 2) {
					Vlevel = 0;
					Veach = false;
					VoneOf = false;
					VtheTotal = true;
					VTrans20((VRootR+VRootL)/2+2,(VRootB+VRootT)/2);
					drawState();
				}
			} else if ((e.x>VBlock1L)&&(e.x<VBlock1R)&&(e.y>VBlocksT)&&(e.y<VBlocksB)) {
				if (Vlevel == 1) {
					newChoice = 0;
					for (i=0;i<numLevel1s;i++)
						if (e.y>VBlocksT+(i*(VBlocksB-VBlocksT))/numLevel1s)
							newChoice = i;
					if (newChoice != VChoice1) {
						VChoice1 = newChoice;
						if (VChoice1 == Week) {
							Veach = true;
							VoneOf = false;
							VtheTotal = false;
						}
						VTrans211((VBlock1R+VBlock1L)/2,VBlocksT+(((2*newChoice+1)*(VBlocksB-VBlocksT))/2)/numLevel1s);
						drawState();
					}
				} else if (Vlevel == 2) {
					newChoice = 0;
					for (i=0;i<numLevel1s;i++)
						if (e.y>VBlocksT+(i*(VBlocksB-VBlocksT))/numLevel1s)
							newChoice = i;
					Vlevel = 1;
					VChoice1 = newChoice;
					Veach = true;
					VoneOf = false;
					VtheTotal = false;
					VTrans211((VBlock1R+VBlock1L)/2,VBlocksT+(((2*newChoice+1)*(VBlocksB-VBlocksT))/2)/numLevel1s);
					drawState();
				}
			} else if ((e.x>VBlock2L)&&(e.x<VBlock2R)&&(e.y>VBlocksT)&&(e.y<VBlocksB)) {
				if (Vlevel == 2) {
					newChoice = 0;
					for (i=0;i<numLevel2s[VChoice1];i++)
						if (e.y>VBlocksT+(i*(VBlocksB-VBlocksT))/numLevel2s[VChoice1])
							newChoice = i;
					if (newChoice != VChoice2) {
						VChoice2 = newChoice;
						VTrans22((VBlock2R+VBlock2L)/2,VBlocksT+(((2*newChoice+1)*(VBlocksB-VBlocksT))/2)/numLevel2s[VChoice1]);
						drawState();
					}
				}
			} else if ((e.x>VBlock3L)&&(e.x<VBlock3R)&&(e.y>VBlocksT)&&(e.y<VBlocksB)) {
				if (Vlevel == 0) {
					newChoice = 0;
					for (i=0;i<numLevel1s;i++)
						if (e.y>VBlocksT+(i*(VBlocksB-VBlocksT))/numLevel1s)
							newChoice = i;
					Vlevel = 1;
					VChoice1 = newChoice;
					Veach = true;
					VoneOf = false;
					VtheTotal = false;
					VTrans01((VBlock3R+VBlock3L)/2,VBlocksT+(((2*newChoice+1)*(VBlocksB-VBlocksT))/2)/numLevel1s);
					drawState();
				} else if (Vlevel == 1) {
					if (VChoice1 != Week) {
						newChoice = 0;
						for (i=0;i<numLevel2s[VChoice1];i++)
							if (e.y>VBlocksT+(i*(VBlocksB-VBlocksT))/numLevel2s[VChoice1])
								newChoice = i;
						Vlevel = 2;
						VChoice2 = newChoice;
						Veach = true;
						VoneOf = false;
						VtheTotal = false;
						VTrans12((VBlock3R+VBlock3L)/2,VBlocksT+(((2*newChoice+1)*(VBlocksB-VBlocksT))/2)/numLevel2s[VChoice1]);
						drawState();
					}
				} else if (Vlevel == 2) {
					newChoice = 0;
					for (i=0;i<numLevel3s[VChoice1][VChoice2];i++) {
						if (e.y>VBlocksT+(i*(VBlocksB-VBlocksT))/numLevel3s[VChoice1][VChoice2]) {
							newChoice = i;
						}
					}
					if (VoneOf) {
						if (newChoice != VtheOne) {
							VtheOne = newChoice;
							drawState();
						}
					} else {
						Veach = false;
						VoneOf = true;
						VtheTotal = false;
						VtheOne = newChoice;
						drawState();
					}
				}
			} else if ((e.x>VTotalL)&&(e.x<VTotalR)&&(e.y>VTotalT)&&(e.y<VTotalB)) {
				if (e.y > (VTotalT+VTotalB)/2) {
					if (Vlevel != 0) {
						Veach = true;
						VoneOf = false;
						VtheTotal = false;
					}
					if (smoothTransition)
						drawBurst((VTotalR+VTotalL)/2,VTotalT+((VTotalB-VTotalT)*3)/4);
				} else {
					Veach = false;
					VoneOf = false;
					VtheTotal = true;
					if (smoothTransition)
						drawBurst((VTotalR+VTotalL)/2,VTotalT+(VTotalB-VTotalT)/4);
				}
				drawState();
			} else if ((e.x>HRootL)&&(e.x<(HRootL+HRootWidth))&&(e.y>HRootT)&&(e.y<(HRootT+HRootHeight))) {
				if (Hlevel == 1) {
					Hlevel = 0;
					Heach = false;
					HoneOf = false;
					HtheTotal = true;
					HTrans10((HRootR+HRootL)/2,(HRootB+HRootT)/2-2);
					drawState();
				} else if (Hlevel == 2) {
					Hlevel = 0;
					Heach = false;
					HoneOf = false;
					HtheTotal = true;
					HTrans20((HRootR+HRootL)/2,(HRootB+HRootT)/2-2);
					drawState();
				}
			} else if ((e.x>HBlocksL)&&(e.x<HBlocksR)&&(e.y>HBlock1T)&&(e.y<HBlock1B)) {
				if (Hlevel == 1) {
					newChoice = 0;
					for (i=0;i<numLevel1s;i++)
						if (e.x>HBlocksL+(i*(HBlocksR-HBlocksL))/numLevel1s)
							newChoice = i;
					if (newChoice != HChoice1) {
						HChoice1 = newChoice;
						if (HChoice1 == Week) {
							Heach = true;
							HoneOf = false;
							HtheTotal = false;
						}
						HTrans211(HBlocksL+(((2*newChoice+1)*(HBlocksR-HBlocksL))/2)/numLevel1s,(HBlock1B+HBlock1T)/2);
						drawState();
					}
				} else if (Hlevel == 2) {
					newChoice = 0;
					for (i=0;i<numLevel1s;i++)
						if (e.x>HBlocksL+(i*(HBlocksR-HBlocksL))/numLevel1s)
							newChoice = i;
					Hlevel = 1;
					HChoice1 = newChoice;
					Heach = true;
					HoneOf = false;
					HtheTotal = false;
					HTrans211(HBlocksL+(((2*newChoice+1)*(HBlocksR-HBlocksL))/2)/numLevel1s,(HBlock1B+HBlock1T)/2);
					drawState();
				}
			} else if ((e.x>HBlocksL)&&(e.x<HBlocksR)&&(e.y>HBlock2T)&&(e.y<HBlock2B)) {
				if (Hlevel == 2) {
					newChoice = 0;
					for (i=0;i<numLevel2s[HChoice1];i++)
						if (e.x>HBlocksL+(i*(HBlocksR-HBlocksL))/numLevel2s[HChoice1])
							newChoice = i;
					if (newChoice != HChoice2) {
						HChoice2 = newChoice;
						HTrans22(HBlocksL+(((2*newChoice+1)*(HBlocksR-HBlocksL))/2)/numLevel2s[HChoice1],(HBlock2B+HBlock2T)/2);
						drawState();
					}
				}
			} else if ((e.x>HBlocksL)&&(e.x<HBlocksR)&&(e.y>HBlock3T)&&(e.y<HBlock3B)) {
				if (Hlevel == 0) {
					newChoice = 0;
					for (i=0;i<numLevel1s;i++)
						if (e.x>HBlocksL+(i*(HBlocksR-HBlocksL))/numLevel1s)
							newChoice = i;
					Hlevel = 1;
					HChoice1 = newChoice;
					Heach = true;
					HoneOf = false;
					HtheTotal = false;
					HTrans01(HBlocksL+(((2*newChoice+1)*(HBlocksR-HBlocksL))/2)/numLevel1s,(HBlock3B+HBlock3T)/2);
					drawState();
				} else if (Hlevel == 1) {
					if (HChoice1 != Week) {
						newChoice = 0;
						for (i=0;i<numLevel2s[HChoice1];i++)
							if (e.x>HBlocksL+(i*(HBlocksR-HBlocksL))/numLevel2s[HChoice1])
								newChoice = i;
						Hlevel = 2;
						HChoice2 = newChoice;
						Heach = true;
						HoneOf = false;
						HtheTotal = false;
						HTrans12(HBlocksL+(((2*newChoice+1)*(HBlocksR-HBlocksL))/2)/numLevel2s[HChoice1],(HBlock3B+HBlock3T)/2);
						drawState();
					}
				} else if (Hlevel == 2) {
					newChoice = 0;
					for (i=0;i<numLevel3s[HChoice1][HChoice2];i++) {
						if (e.x>HBlocksL+(i*(HBlocksR-HBlocksL))/numLevel3s[HChoice1][HChoice2]) {
							newChoice = i;
						}
					}
					if (HoneOf) {
						if (newChoice != HtheOne) {
							HtheOne = newChoice;
							drawState();
						}
					} else {
						Heach = false;
						HoneOf = true;
						HtheTotal = false;
						HtheOne = newChoice;
						drawState();
					}
				}
			} else if ((e.x>HTotalL)&&(e.x<HTotalR)&&(e.y>HTotalT)&&(e.y<HTotalB)) {
				if (e.y > (HTotalT+HTotalB)/2) {
					if (Hlevel != 0) {
						Heach = true;
						HoneOf = false;
						HtheTotal = false;
					}
					if (smoothTransition)
						drawBurst((HTotalR+HTotalL)/2,HTotalT+((HTotalB-HTotalT)*3)/4);
				} else {
					Heach = false;
					HoneOf = false;
					HtheTotal = true;
					if (smoothTransition)
						drawBurst((HTotalR+HTotalL)/2,HTotalT+(HTotalB-HTotalT)/4);
				}
				drawState();
			}
			processingEvent = false;
		}
		return(true);
	}
}

/* This is the thread which runs the demo.  It basically feeds events to the above applet. */
class demoThread extends Thread {

	dbViewer theParent;
	Event theEvent;
	boolean tryingToStop = false;

	public void setParent(dbViewer inParent) {

		theParent = inParent;
	}

	private void doSleep(int duration) {

		if (tryingToStop) {
			theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.DemoL+2,theParent.DemoT+2,0,0);
			theParent.handleEvent(theEvent);
		}
		try {
			this.sleep(duration);
		} catch (InterruptedException e) {
			System.out.println("Interrupted...");
		};
	}

	public void run() {

		if ((theParent.Vlevel != 0) || (theParent.Hlevel != 0)) {
			/* reset vertical and horizontal */
			theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.VRootL+2+1000,theParent.VRootT+2+1000,0,0);
			theParent.handleEvent(theEvent);
			theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.HRootL+2+1000,theParent.HRootT+2+1000,0,0);
			theParent.handleEvent(theEvent);
			doSleep(2000);
		}
		/* click on V GlobalZone */
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.VBlock3L+2+1000,theParent.VBlocksT+2+1000,0,0);
		theParent.handleEvent(theEvent);
		doSleep(2000);
		/* click on H Quarter */
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.HBlocksL+210+1000,theParent.HBlock3T+2+1000,0,0);
		theParent.handleEvent(theEvent);
		doSleep(2000);
		/* click on V North America */
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.VBlock3L+2+1000,theParent.VBlocksT+2+1000,0,0);
		theParent.handleEvent(theEvent);
		doSleep(2000);
		/* click on V total */
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.VTotalL+2+1000,theParent.VTotalT+2+1000,0,0);
		theParent.handleEvent(theEvent);
		doSleep(2000);
		/* click on V all */
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.VBlock3L+2+1000,theParent.VTotalB-2+1000,0,0);
		theParent.handleEvent(theEvent);
		doSleep(2000);
		/* click on H total */
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.HTotalL+2+1000,theParent.HTotalT+2+1000,0,0);
		theParent.handleEvent(theEvent);
		doSleep(2000);
		/* click on V root */
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.HRootL+2+1000,theParent.HRootT+2+1000,0,0);
		theParent.handleEvent(theEvent);
		doSleep(2000);
		/* click on H root */
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.VRootL+2+1000,theParent.VRootT+2+1000,0,0);
		theParent.handleEvent(theEvent);
		theEvent = new Event(theParent,0,Event.MOUSE_DOWN,theParent.DemoL+2,theParent.DemoT+2,0,0);
		theParent.handleEvent(theEvent);
	}
}