import java.util.*;

public class CompElement {

    QueryableComponent comp;
    String      symbSQL;
    boolean     isStable;
    Hashtable   dependentOn;
    Hashtable   defines;
    String      placeHolder;

    CompElement(QueryableComponent qc) {
        comp = qc;
        dependentOn = new Hashtable();
        defines = new Hashtable();
        isStable = false;
        parseSQL();
    }

    void requeryNew() {
    QueryableComponent recomp;
      comp.refreshSQL();
      return;
    }

    void requery() {
    QueryableComponent recomp;
      comp.refreshSQL();

      switch (comp.getWidgetType()) {
        case comp.LIST_TYPE: {
            DBList dbl = (DBList)comp;
            comp = new DBList(dbl.getRows(), dbl.db, dbl.sql);
            break;
        }
        case comp.CHOICE_TYPE: {
            DBChoice dbc = (DBChoice)comp;
            comp = new DBChoice(dbc.db, dbc.sql);
            break;
        }
        case comp.TEXT_FIELD_TYPE: {
            DBTextField dbt = (DBTextField)comp;
            comp = new DBTextField(dbt.db, dbt.sql);
            break;
        }
        case comp.SHEET_TYPE: {
            DBSheet dbs = (DBSheet)comp;
            comp = new DBSheet(dbs.db, dbs.sql, dbs.size, dbs.head);
            break;
        }
      }
    }

    void add(DBPanel dbpanel) {

      QueryableComponent recomp;
      comp.refreshSQL();
      comp.setDBPanel(dbpanel);


      switch (comp.getWidgetType()) {
        case comp.LIST_TYPE: {
            DBList dbl = (DBList)comp;
            dbl.getDBPanel().add(dbl);
            break;
        }
        case comp.CHOICE_TYPE: {
            DBChoice dbc = (DBChoice)comp;
            dbc.getDBPanel().add(dbc);
            break;
        }
        case comp.TEXT_FIELD_TYPE: {
            DBTextField dbt = (DBTextField)comp;
            dbt.getDBPanel().add(dbt);
            break;
        }
        case comp.SHEET_TYPE: {
            DBSheet dbs = (DBSheet)comp;
            dbs.getDBPanel().add(dbs);
            break;
        }
      }
    }

    void remove() {
    QueryableComponent recomp;
      comp.refreshSQL();

      switch (comp.getWidgetType()) {
        case comp.LIST_TYPE: {
            DBList dbl = (DBList)comp;
            dbl.getDBPanel().remove(dbl);
            break;
        }
        case comp.CHOICE_TYPE: {
            DBChoice dbc = (DBChoice)comp;
            dbc.getDBPanel().remove(dbc);
            break;
        }
        case comp.TEXT_FIELD_TYPE: {
            DBTextField dbt = (DBTextField)comp;
            dbt.getDBPanel().remove(dbt);
            break;
        }
        case comp.SHEET_TYPE: {
            DBSheet dbs = (DBSheet)comp;
            dbs.getDBPanel().remove(dbs);
            break;
        }
      }
    }

//
// Computes Components that current component is dependent on
//
    void parseSQL() {
        int i=0;
        int j=0;
        String sqlText;
        String tag;

        sqlText = comp.getSQLText();

        while (i >= 0) {
            i = sqlText.indexOf(":",i);
            if (i >= 0) {
                j = sqlText.indexOf(" ",i);
                if (j < 0) {
                    j = sqlText.length()-1;
                }
                tag = new String(sqlText.substring(i+1,j));
                dependentOn.put(tag, "data");
                i = j;
            }
        }
    }

    public String toString() {
        return "CompElement: comp="+comp+" parsedSQL="+symbSQL+
                " isStable="+isStable+" depOn="+dependentOn+
                " defines="+defines;
    }
}