import java.util.*;
import java.io.*;
import java.lang.Math;
import java.net.*;

import Database;
import DSRow;
import Dataset;

public class DemoDataset extends Dataset{

int ySize;
int xSize;

 DemoDataset() {
    ySize = 30;
    xSize = 6;

    db = null;
    query = null;
    go();
  }

 DemoDataset(int rsize, int csize) {
   ySize = rsize;
   xSize = csize;

    db = null;
    query = null;
    go();
  }

 boolean getQueryFields() {
 	rowSize = 0;
    
	    colCount = (short)(xSize);
 
	    if (colCount <= 0) {
	      return(true);
	    }
 
	    colType = new byte[colCount];
	    colSize = new int[colCount];
	    colName = new String[colCount];
	    colOffset = new int[colCount];

	    for (int i=0; i < colCount; i++) {
	      colOffset[i] = rowSize;
	      colType[i] = DSRow.INT_TYPE;
	      System.out.println("type:"+colType[i]);
//  	      b1 = db.din.readByte();
//	      b2 = db.din.readByte();
//	      colSize[i] = (short)(b1+b2*256);

    	      System.out.println("sz:"+colSize[i]);
    	
	      if (colType[i] == DSRow.REAL_TYPE) {colSize[i]=4;}
 	      if (colType[i] == DSRow.CHAR_TYPE) {colSize[i]+=2;}
   	  
//	      colName[i] = db.din.readUTF(); 
		 colName[i] = new String("col"+i);
    	      System.out.println("cn:"+colName[i]);            
	      rowSize += (short) colSize[i];
	      
	      if (colType[i] == DSRow.INT_TYPE) {rowSize += 2;}
	    }
	    
	    System.out.println("Row Size = "+rowSize);
    
    return(false);
  }
  
  boolean getRows() {
//   byte b1 = db.din.readByte();
//	byte b2 = db.din.readByte();
//  	rowCount = (short)(b1+b2*256);
	rowCount = ySize;
	
	System.out.println("rowCount = "+rowCount+" rowsize = "+rowSize);
    	blockSize = rowCount * rowSize;
    	rowData = new byte[blockSize];
//	db.din.readFully(rowData, 0, blockSize);
//  	db.din.readByte();
	int ii=0;
	for (int i=0; i <= blockSize - 4; i+=4) {
		ii++;
		if (ii > 100) { ii=0;}
		rowData[i] = (byte) 0;
		rowData[i+1] = (byte) 0;
		rowData[i+2] = (byte) 0;
		rowData[i+3] = (byte) ii ;
	}
	
	qb = new DataInputStream(new ByteArrayInputStream(rowData));
 
    return(false);
  }
  
  public boolean go() {
    byte stat;
//  	db.dout.writeByte(db.MSG_QUERY);
//	db.dout.writeUTF(query);
//  	db.dout.flush();
	if (getQueryFields()) {
    	  return(true);
	}
    	System.out.println("QueryFields Complete!");
	if (getRows()) {
      		return(true);
    	}
	System.out.println("Creating Row");    	
	row = new DSRow(qb, colCount, colType, colSize);
	rowCurrent = 0;
	
    return(false);
  }
  

  public boolean goNodb() {
    byte stat;
	if (getQueryFields()) {
    	  return(true);
	}
    	System.out.println("QueryFields Complete!");
	if (getRows()) {
      		return(true);
    	}
	System.out.println("Creating Row");    	
	row = new DSRow(qb, colCount, colType, colSize);
	rowCurrent = 0;
 
    return(false);
  }
  
  public boolean gotoRow(int rowNum) {
    if (rowNum >= rowCount) {
       return(true);
    }
    try {
	    qb.reset();
	    qb.skip(rowNum*rowSize);
	    row.fetch();
    } catch (IOException e) {
    	e.printStackTrace();
      	System.err.println(e.getMessage());    	
    }	   
    return(false);
  }
}
