/*  No copyright is claimed [For this document], but the author requests the following
	information be included anywhere this code is used.
	written 1996 as part of submission for Sun's Java Cup...questions & comments happily accepted.
	Miles T. Parker, Software Development & Consulting
	Washington, DC. miles@clark.net (202) 232-1468												*/	
	
public class Arrow extends RankedRecord {

	public int target_id, origin_id, type;
	
	public static final int SUPPORT = 0;
	public static final int REBUT = 1;
	public static final int WARRANT = 2;
	
	public Arrow () {
		target_id = 0;
		origin_id = 0;
		type = 0;
	}
	
	public Arrow (int target_id, int origin_id, int type) {
		this.target_id = target_id;
		this.origin_id = origin_id;
		this.type = type;
	}
	
	public boolean equals(int fieldNumber, int assignedNumber) {
		switch (fieldNumber) {
			case 0:
				if(target_id == assignedNumber) {
					return true;
				};
				break;
			case 1:
				if(origin_id == assignedNumber) {
					return true;
				};
				break;
			default:
		}
		return false;
	}
	
	public void assignField (int fieldNumber, double assignedNumber) {
		switch (fieldNumber) {
			case 0:
				target_id = (int) assignedNumber;
				break;
			case 1:
				origin_id = (int) assignedNumber;
				break;
			case 2:
				type = (int) assignedNumber;
				break;
			default:
				System.out.println("Error in assigning field!");
		}
	}
	
	public static String typeName(int type) {
		switch (type) {
			case SUPPORT:	{return "support";}
			case REBUT:	{return "rebuttal";}
			case WARRANT:	{return "warrant";}
			default: {return "";}
		}
	}
	
	public String toString() {
		return "arrow from "+Integer.toString(origin_id)+" to "+Integer.toString(target_id);
	}
}	
