/*  No copyright is claimed [For this document], but the author requests the following
	information be included anywhere this code is used.
	written 1996 as part of submission for Sun's Java Cup...questions & comments happily accepted.
	Miles T. Parker, Software Development & Consulting
	Washington, DC. miles@clark.net (202) 232-1468												*/	
	
import java.awt.Font;
import java.awt.Point;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.util.*;

/** */
public class ConstrainableDrawableText extends DrawableText {

	private Vector string_lines;
	private int constraint = 0;
	private boolean constrain = false;
	private String currentToken;

	public ConstrainableDrawableText (Graphics g, String string, Font font, int constraint) {
		super(g, string, font);
		constrain = true;
		this.constraint = constraint;
		initialize();
	}
	
	public void initialize() {
		string_lines = new Vector();

		if (constrain && (constraint < (super.line_width() + this.leading()))) {

			StringTokenizer parsedString = new StringTokenizer(string);

			try {
				currentToken = parsedString.nextToken();
				while (true) {
					string_lines.addElement(new StringBuffer(currentToken));
					int line_length = metrics.stringWidth(currentToken) + this.leading();
					currentToken = parsedString.nextToken();
					while ((line_length + metrics.stringWidth(" " + currentToken)) < constraint) {
						string_lines.setElementAt(string_lines.lastElement() +" "+ currentToken, (string_lines.size() - 1));
						line_length = line_length +  metrics.stringWidth(" " + currentToken);
						currentToken = parsedString.nextToken();
					}
				}
			}
			catch (NoSuchElementException e) { //Nothing left to process
			} 
		}
		else {
			string_lines.addElement(new StringBuffer(string));
		}
		super.initialize();
	}
	
	public int width () {
		if (constrain) {
			if (string_lines.size() > 1) {
				return this.constraint;
			}
			else {
				return metrics.stringWidth(this.toString()) + this.leading();
			}
		}
		else {
			return metrics.stringWidth(this.toString()) + this.leading();
		}
	} 
	
	public int height () {
		return line_height() * string_lines.size();
	} 
	
	public void paint (Graphics g, int x, int y) {
		g.setFont(this.font);
		Enumeration strings = string_lines.elements();
		int i = 0;
		while (strings.hasMoreElements()) {
			String tempString = strings.nextElement().toString();
			g.drawString(tempString, x, y + (i * this.line_height()) + this.line_ascent());	
			i++;			
		}
	}

	public int getConstraint() {return constraint;}
}
