/*  No copyright is claimed [For this document], but the author requests the following
	information be included anywhere this code is used.
	written 1996 as part of submission for Sun's Java Cup...questions & comments happily accepted.
	Miles T. Parker, Software Development & Consulting
	Washington, DC. miles@clark.net (202) 232-1468												*/	
	
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Color;

public class DrawableArrow extends Arrow implements Drawable {

	public Point origin;
	public Point target;
	public boolean drawable;
	
	public static Color support_arrow_color = new Color(0xAE, 0xAE, 0xFF);
	public static Color rebut_arrow_color = new Color(0xFF, 0xAE, 0xAE);
	public static Color warrant_arrow_color = new Color(0x00, 0xFF, 0xC0);
	
	public DrawableArrow () {
		super();
		origin = new Point(0,0); //the Arrow dosn't have a position till it's appropriate
		target = new Point(0,0); 
		drawable = false;
	}
	
	public DrawableArrow (int target_id, int origin_id, int type) {
		super(target_id, origin_id, type);
		origin = new Point(0,0); //the Arrow dosn't have a position till it's appropriate
		target = new Point(0,0); 
		drawable = false;
	}
	
	public void paint (Graphics g) {
		if(drawable) {
		
			switch (this.type) {
				case this.REBUT: {
					g.setColor(rebut_arrow_color);		
					break;	
				}
				case this.SUPPORT: {
					g.setColor(support_arrow_color);			
					break;	
				}
				case this.WARRANT: {
					g.setColor(warrant_arrow_color);			
					break;	
				}
			}
			g.drawLine(origin.x - 1,origin.y,target.x - 1,target.y);
			g.drawLine(origin.x,origin.y,target.x,target.y);
			g.drawLine(origin.x + 1,origin.y,target.x + 1,target.y);
			g.fillOval(target.x - 1, target.y - 1, 5, 5);
		}
	}
}
