/*  No copyright is claimed [For this document], but the author requests the following
	information be included anywhere this code is used.
	written 1996 as part of submission for Sun's Java Cup...questions & comments happily accepted.
	Miles T. Parker, Software Development & Consulting
	Washington, DC. miles@clark.net (202) 232-1468												*/	
	
import java.awt.Font;
import java.awt.Point;
import java.awt.FontMetrics;
import java.awt.Graphics;

/**Despite its name*/
public class DrawableText extends Object {


	private protected Font font;
	private protected FontMetrics metrics;
	private protected Point extent;
	private protected String string;

	private boolean preparedForDrawing;

	public DrawableText (Graphics g, String string, Font font) {
		this.string = new String(string);
		this.font = font;
		metrics = g.getFontMetrics(font);
		initialize();  //We put this last in the constructor statement so it can be overridden.
	}
	
	public void initialize () {
		extent =  new Point(this.width(), this.height());
		preparedForDrawing = true;
	}
	
	public int line_width () {
		return metrics.stringWidth(string) + this.leading();
	} 
	
	public int line_height () {
		return metrics.getHeight();
	} 
	
	public int line_ascent () {
		return metrics.getAscent();
	} 
	
	public int line_descent () {
		return metrics.getDescent();
	} 
	
	public int leading () {
		return metrics.getLeading();
	} 
	
	public int width () {
		return line_width() + leading();
	} 
	
	public int height () {
		return line_height();
	} 
	
	public void setFont (Graphics g, Font font) {
		metrics = g.getFontMetrics(font);
	} 
	
	public Point getExtent () {
		return extent;
	}
	
	public void paint (Graphics g, int x, int y) {
		g.setFont(this.font);
		g.drawString(this.toString(), x, y + this.line_ascent());		
	}
	
	public String toString() {return string;}
}
