/*  No copyright is claimed [For this document], but the author requests the following
	information be included anywhere this code is used.
	written 1996 as part of submission for Sun's Java Cup...questions & comments happily accepted.
	Miles T. Parker, Software Development & Consulting
	Washington, DC. miles@clark.net (202) 232-1468												*/	
	
/** Look at catoTables.java for an example of how to appropriatly subclass.*/
import java.io.*;
import java.util.*;
import java.net.*;

public class StreamOfTables{
	public Table[] tables;
	public InputStream fileStream;

	public static final String space = " ";
	public static final String quote = "\"";
	public static final char charSpace = space.charAt(0);
	public static final char charQuote = quote.charAt(0);
	public static final int intQuote = 34;

	private StreamTokenizer tokenStream;

	public Record tempRecord;
	private boolean infile = true;
	private boolean fNewRecord = true;
	private int myToken;
	private int lTable;
	private int lField;
	private int lPrint;
	private int i;
	private int tableLength;
	private Record currentRecord;
	
	public StreamOfTables (InputStream fileStream, int tableLength) {
		fileStream = new PushbackInputStream(fileStream);
		tokenStream = new StreamTokenizer(fileStream);		
		this.fileStream = fileStream;
		tables = new Table[tableLength]; 
	}
	
	public Record addRecord (int index) {  //Class id designed to be over-ridden by class defining table
		switch(index) {
			default:
				tempRecord = new Record();
				return tempRecord;
		}	
	}
	
	public void read() {
		
		tokenStream.eolIsSignificant(true);
		tokenStream.quoteChar(intQuote);
		
		lTable = 0;
		fNewRecord = true;
		infile = true;
		
		while(infile) {
			
			try {
				myToken = tokenStream.nextToken();
			}
			catch (IOException e) {
					System.out.println(e);
			}
			
			if ((fNewRecord) && (myToken != StreamTokenizer.TT_EOL) && (myToken != StreamTokenizer.TT_EOF) && (myToken != StreamTokenizer.TT_WORD)) {
				//If the last token was an end of line, or we are at the begining of file; and the current token
				//isn't the last token in file or another EOL. (No point in writing a blank record.)
				tempRecord = addRecord(lTable);
				tables[lTable].addElement(tempRecord);
				lField = 0;  //Set field back to first field
				fNewRecord = false;
			}
			
			switch(myToken) {
				case intQuote:  //Regular text data
					tempRecord.assignField(lField, tokenStream.sval);
					lField++;
					break;
				case StreamTokenizer.TT_NUMBER: //Regular number data
					tempRecord.assignField(lField, tokenStream.nval);
					lField++;
					break;
				case StreamTokenizer.TT_EOL:  //Next Row in Table
					fNewRecord = true;
					break;
				case StreamTokenizer.TT_WORD: //Any unquoted word signals next table
					lTable = lTable + 1;
					break;
				case StreamTokenizer.TT_EOF:  //We're at the end of file
					infile = false;
					break;
				default:
					System.out.println("Error reading stream of tables.");
			}
		}
	}
	
	public void print() {
		
		for (int i=0; i<tables.length; i++) {
			for (int j=0; j<tables[i].size(); j++) {
				tempRecord = (Record) tables[i].elementAt(j);
				tempRecord.print();
			}
		}
	}
}
